<?php
/** Adminer Editor - Compact database editor
* @link https://www.adminer.org/
* @author Jakub Vrana, https://www.vrana.cz/
* @copyright 2009 Jakub Vrana
* @license https://www.apache.org/licenses/LICENSE-2.0 Apache License, Version 2.0
* @license https://www.gnu.org/licenses/gpl-2.0.html GNU General Public License, version 2 (one or other)
* @version 4.8.3
*/function
adminer_errors($_b,$Ab){return!!preg_match('~^(Trying to access array offset on value of type null|Undefined array key)~',$Ab);}error_reporting(6135);set_error_handler('adminer_errors',E_WARNING);$Mb=!preg_match('~^(unsafe_raw)?$~',ini_get("filter.default"));if($Mb||ini_get("filter.default_flags")){foreach(array('_GET','_POST','_COOKIE','_SERVER')as$W){$Se=filter_input_array(constant("INPUT$W"),FILTER_UNSAFE_RAW);if($Se)$$W=$Se;}}if(function_exists("mb_internal_encoding"))mb_internal_encoding("8bit");function
connection(){global$f;return$f;}function
adminer(){global$b;return$b;}function
version(){global$ca;return$ca;}function
idf_unescape($t){if(!preg_match('~^[`\'"[]~',$t))return$t;$Cc=substr($t,-1);return
str_replace($Cc.$Cc,$Cc,substr($t,1,-1));}function
escape_string($W){return
substr(q($W),1,-1);}function
number($W){return
preg_replace('~[^0-9]+~','',$W);}function
number_type(){return'((?<!o)int(?!er)|numeric|real|float|double|decimal|money)';}function
remove_slashes($Ed,$Mb=false){if(function_exists("get_magic_quotes_gpc")&&get_magic_quotes_gpc()){while(list($y,$W)=each($Ed)){foreach($W
as$xc=>$V){unset($Ed[$y][$xc]);if(is_array($V)){$Ed[$y][stripslashes($xc)]=$V;$Ed[]=&$Ed[$y][stripslashes($xc)];}else$Ed[$y][stripslashes($xc)]=($Mb?$V:stripslashes($V));}}}}function
bracket_escape($t,$ta=false){static$Je=array(':'=>':1',']'=>':2','['=>':3','"'=>':4');return
strtr($t,($ta?array_flip($Je):$Je));}function
min_version($af,$Mc="",$g=null){global$f;if(!$g)$g=$f;$ce=$g->server_info;if($Mc&&preg_match('~([\d.]+)-MariaDB~',$ce,$B)){$ce=$B[1];$af=$Mc;}return(version_compare($ce,$af)>=0);}function
charset($f){return(min_version("5.5.3",0,$f)?"utf8mb4":"utf8");}function
script($ie,$Ie="\n"){return"<script".nonce().">$ie</script>$Ie";}function
script_src($We){return"<script src='".h($We)."'".nonce()."></script>\n";}function
nonce(){return' nonce="'.get_nonce().'"';}function
target_blank(){return' target="_blank" rel="noreferrer noopener"';}function
h($R){return
str_replace("\0","&#0;",htmlspecialchars($R,ENT_QUOTES,'utf-8'));}function
nl_br($R){return
str_replace("\n","<br>",$R);}function
checkbox($E,$X,$Da,$_c="",$gd="",$Ga="",$Ac=""){$L="<input type='checkbox' name='$E' value='".h($X)."'".($Da?" checked":"").($Ac?" aria-labelledby='$Ac'":"").">".($gd?script("qsl('input').onclick = function () { $gd };",""):"");return($_c!=""||$Ga?"<label".($Ga?" class='$Ga'":"").">$L".h($_c)."</label>":$L);}function
optionlist($F,$Xd=null,$Ye=false){$L="";foreach($F
as$xc=>$V){$ld=array($xc=>$V);if(is_array($V)){$L.='<optgroup label="'.h($xc).'">';$ld=$V;}foreach($ld
as$y=>$W)$L.='<option'.($Ye||is_string($y)?' value="'.h($y).'"':'').(($Ye||is_string($y)?(string)$y:$W)===$Xd?' selected':'').'>'.h($W);if(is_array($V))$L.='</optgroup>';}return$L;}function
html_select($E,$F,$X="",$fd=true,$Ac=""){if($fd)return"<select name='".h($E)."'".($Ac?" aria-labelledby='$Ac'":"").">".optionlist($F,$X)."</select>".(is_string($fd)?script("qsl('select').onchange = function () { $fd };",""):"");$L="";foreach($F
as$y=>$W)$L.="<label><input type='radio' name='".h($E)."' value='".h($y)."'".($y==$X?" checked":"").">".h($W)."</label>";return$L;}function
select_input($c,$F,$X="",$fd="",$xd=""){$we=($F?"select":"input");return"<$we$c".($F?"><option value=''>$xd".optionlist($F,$X,true)."</select>":" size='10' value='".h($X)."' placeholder='$xd'>").($fd?script("qsl('$we').onchange = $fd;",""):"");}function
confirm($C="",$Yd="qsl('input')"){return
script("$Yd.onclick = function () { return confirm('".($C?js_escape($C):'您确定吗？')."'); };","");}function
print_fieldset($s,$Ec,$cf=false){echo"<fieldset><legend>","<a href='#fieldset-$s'>$Ec</a>",script("qsl('a').onclick = partial(toggle, 'fieldset-$s');",""),"</legend>","<div id='fieldset-$s'".($cf?"":" class='hidden'").">\n";}function
generate_linksbar($Ic){$Jc="<p class='links'>";foreach($Ic
as$y=>$_){if($y!==key(array_keys($Ic)))$Jc.="<span class='separator'>|</span>";$Jc.=$_;}$Jc.="</p>";return$Jc;}function
bold($_a,$Ga=""){return($_a?" class='active $Ga'":($Ga?" class='$Ga'":""));}function
odd($L=' class="odd"'){static$r=0;if(!$L)$r=-1;return($r++%2?$L:'');}function
js_escape($R){return
addcslashes($R,"\r\n'\\/");}function
json_row($y,$W=null){static$Nb=true;if($Nb)echo"{";if($y!=""){echo($Nb?"":",")."\n\t\"".addcslashes($y,"\r\n\t\"\\/").'": '.($W!==null?'"'.addcslashes($W,"\r\n\"\\/").'"':'null');$Nb=false;}else{echo"\n}\n";$Nb=true;}}function
ini_bool($qc){$W=ini_get($qc);return(preg_match('~^(on|true|yes)$~i',$W)||(int)$W);}function
sid(){static$L;if($L===null)$L=(SID&&!($_COOKIE&&ini_bool("session.use_cookies")));return$L;}function
set_password($Y,$P,$U,$I){$_SESSION["pwds"][$Y][$P][$U]=($_COOKIE["adminer_key"]&&is_string($I)?array(encrypt_string($I,$_COOKIE["adminer_key"])):$I);}function
get_password(){$L=get_session("pwds");if(is_array($L))$L=($_COOKIE["adminer_key"]?decrypt_string($L[0],$_COOKIE["adminer_key"]):false);return$L;}function
q($R){global$f;return$f->quote($R);}function
get_vals($J,$d=0){global$f;$L=array();$K=$f->query($J);if(is_object($K)){while($M=$K->fetch_row())$L[]=$M[$d];}return$L;}function
get_key_vals($J,$g=null,$fe=true){global$f;if(!is_object($g))$g=$f;$L=array();$K=$g->query($J);if(is_object($K)){while($M=$K->fetch_row()){if($fe)$L[$M[0]]=$M[1];else$L[]=$M[0];}}return$L;}function
get_rows($J,$g=null,$j="<p class='error'>"){global$f;$Sa=(is_object($g)?$g:$f);$L=array();$K=$Sa->query($J);if(is_object($K)){while($M=$K->fetch_assoc())$L[]=$M;}elseif(!$K&&!is_object($g)&&$j&&defined("PAGE_HEADER"))echo$j.error()."\n";return$L;}function
unique_array($M,$v){foreach($v
as$u){if(preg_match("~PRIMARY|UNIQUE~",$u["type"])){$L=array();foreach($u["columns"]as$y){if(!isset($M[$y]))continue
2;$L[$y]=$M[$y];}return$L;}}}function
escape_key($y){if(preg_match('(^([\w(]+)('.str_replace("_",".*",preg_quote(idf_escape("_"))).')([ \w)]+)$)',$y,$B))return$B[1].idf_escape(idf_unescape($B[2])).$B[3];return
idf_escape($y);}function
where($Z,$l=array()){global$f,$x;$L=array();foreach((array)$Z["where"]as$y=>$W){$y=bracket_escape($y,1);$d=escape_key($y);$L[]=$d.($x=="sql"&&is_numeric($W)&&preg_match('~\.~',$W)?" LIKE ".q($W):($x=="mssql"?" LIKE ".q(preg_replace('~[_%[]~','[\0]',$W)):" = ".unconvert_field($l[$y],q($W))));if($x=="sql"&&preg_match('~char|text~',$l[$y]["type"])&&preg_match("~[^ -@]~",$W))$L[]="$d = ".q($W)." COLLATE ".charset($f)."_bin";}foreach((array)$Z["null"]as$y)$L[]=escape_key($y)." IS NULL";return
implode(" AND ",$L);}function
where_check($W,$l=array()){parse_str($W,$Ca);remove_slashes(array(&$Ca));return
where($Ca,$l);}function
where_link($r,$d,$X,$id="="){return"&where%5B$r%5D%5Bcol%5D=".urlencode($d)."&where%5B$r%5D%5Bop%5D=".urlencode(($X!==null?$id:"IS NULL"))."&where%5B$r%5D%5Bval%5D=".urlencode($X);}function
convert_fields($e,$l,$O=array()){$L="";foreach($e
as$y=>$W){if($O&&!in_array(idf_escape($y),$O))continue;$oa=convert_field($l[$y]);if($oa)$L.=", $oa AS ".idf_escape($y);}return$L;}function
cookie($E,$X,$Hc=2592000){global$aa;return
header("Set-Cookie: $E=".urlencode($X).($Hc?"; expires=".gmdate("D, d M Y H:i:s",time()+$Hc)." GMT":"")."; path=".preg_replace('~\?.*~','',$_SERVER["REQUEST_URI"]).($aa?"; secure":"")."; HttpOnly; SameSite=lax",false);}function
restart_session(){if(!ini_bool("session.use_cookies"))session_start();}function
stop_session($Pb=false){$Xe=ini_bool("session.use_cookies");if(!$Xe||$Pb){session_write_close();if($Xe&&@ini_set("session.use_cookies",false)===false)session_start();}}function&get_session($y){return$_SESSION[$y][DRIVER][SERVER][$_GET["username"]];}function
set_session($y,$W){$_SESSION[$y][DRIVER][SERVER][$_GET["username"]]=$W;}function
auth_url($Y,$P,$U,$h=null){global$mb;preg_match('~([^?]*)\??(.*)~',remove_from_uri(implode("|",array_keys($mb))."|username|".($h!==null?"db|":"").session_name()),$B);return"$B[1]?".(sid()?SID."&":"").($Y!="server"||$P!=""?urlencode($Y)."=".urlencode($P)."&":"")."username=".urlencode($U).($h!=""?"&db=".urlencode($h):"").($B[2]?"&$B[2]":"");}function
is_ajax(){return($_SERVER["HTTP_X_REQUESTED_WITH"]=="XMLHttpRequest");}function
redirect($A,$C=null){if($C!==null){restart_session();$_SESSION["messages"][preg_replace('~^[^?]*~','',($A!==null?$A:$_SERVER["REQUEST_URI"]))][]=$C;}if($A!==null){if($A=="")$A=".";header("Location: $A");exit;}}function
query_redirect($J,$A,$C,$Md=true,$Eb=true,$Hb=false,$Ae=""){global$f,$j,$b;if($Eb){$ke=microtime(true);$Hb=!$f->query($J);$Ae=format_time($ke);}$je="";if($J)$je=$b->messageQuery($J,$Ae,$Hb);if($Hb){$j=error().$je.script("messagesPrint();");return
false;}if($Md)redirect($A,$C.$je);return
true;}function
queries($J){global$f;static$Hd=array();static$ke;if(!$ke)$ke=microtime(true);if($J===null)return
array(implode("\n",$Hd),format_time($ke));$Hd[]=(preg_match('~;$~',$J)?"DELIMITER ;;\n$J;\nDELIMITER ":$J).";";return$f->query($J);}function
apply_queries($J,$ve,$Bb='table'){foreach($ve
as$S){if(!queries("$J ".$Bb($S)))return
false;}return
true;}function
queries_redirect($A,$C,$Md){list($Hd,$Ae)=queries(null);return
query_redirect($Hd,$A,$C,$Md,false,!$Md,$Ae);}function
format_time($ke){return
sprintf('%.3f 秒',max(0,microtime(true)-$ke));}function
relative_uri(){return
str_replace(":","%3a",preg_replace('~^[^?]*/([^?]*)~','\1',$_SERVER["REQUEST_URI"]));}function
remove_from_uri($rd=""){return
substr(preg_replace("~(?<=[?&])($rd".(SID?"":"|".session_name()).")=[^&]*&~",'',relative_uri()."&"),0,-1);}function
pagination($H,$ab){return" ".($H==$ab?$H+1:'<a href="'.h(remove_from_uri("page").($H?"&page=$H".($_GET["next"]?"&next=".urlencode($_GET["next"]):""):"")).'">'.($H+1)."</a>");}function
get_file($y,$eb=false){$Kb=$_FILES[$y];if(!$Kb)return
null;foreach($Kb
as$y=>$W)$Kb[$y]=(array)$W;$L='';foreach($Kb["error"]as$y=>$j){if($j)return$j;$E=$Kb["name"][$y];$Ge=$Kb["tmp_name"][$y];$Ua=file_get_contents($eb&&preg_match('~\.gz$~',$E)?"compress.zlib://$Ge":$Ge);if($eb){$ke=substr($Ua,0,3);if(function_exists("iconv")&&preg_match("~^\xFE\xFF|^\xFF\xFE~",$ke,$Nd))$Ua=iconv("utf-16","utf-8",$Ua);elseif($ke=="\xEF\xBB\xBF")$Ua=substr($Ua,3);$L.=$Ua."\n\n";}else$L.=$Ua;}return$L;}function
upload_error($j){$Qc=($j==UPLOAD_ERR_INI_SIZE?ini_get("upload_max_filesize"):0);return($j?'不能上传文件。'.($Qc?" ".sprintf('最多允许的文件大小为 %sB。',$Qc):""):'文件不存在。');}function
repeat_pattern($ud,$Fc){return
str_repeat("$ud{0,65535}",$Fc/65535)."$ud{0,".($Fc%65535)."}";}function
is_utf8($W){return(preg_match('~~u',$W)&&!preg_match('~[\0-\x8\xB\xC\xE-\x1F]~',$W));}function
shorten_utf8($R,$Fc=80,$pe=""){if(!preg_match("(^(".repeat_pattern("[\t\r\n -\x{10FFFF}]",$Fc).")($)?)u",$R,$B))preg_match("(^(".repeat_pattern("[\t\r\n -~]",$Fc).")($)?)",$R,$B);return
h($B[1]).$pe.(isset($B[2])?"":"<i>…</i>");}function
format_number($W){return
strtr(number_format($W,0,".",','),preg_split('~~u','0123456789',-1,PREG_SPLIT_NO_EMPTY));}function
friendly_url($W){return
preg_replace('~[^a-z0-9_]~i','-',$W);}function
hidden_fields($Ed,$nc=array(),$Ad=''){$L=false;foreach($Ed
as$y=>$W){if(!in_array($y,$nc)){if(is_array($W))hidden_fields($W,array(),$y);else{$L=true;echo'<input type="hidden" name="'.h($Ad?$Ad."[$y]":$y).'" value="'.h($W).'">';}}}return$L;}function
hidden_fields_get(){echo(sid()?'<input type="hidden" name="'.session_name().'" value="'.h(session_id()).'">':''),(SERVER!==null?'<input type="hidden" name="'.DRIVER.'" value="'.h(SERVER).'">':""),'<input type="hidden" name="username" value="'.h($_GET["username"]).'">';}function
table_status1($S,$Ib=false){$L=table_status($S,$Ib);return($L?$L:array("Name"=>$S));}function
column_foreign_keys($S){global$b;$L=array();foreach($b->foreignKeys($S)as$n){foreach($n["source"]as$W)$L[$W][]=$n;}return$L;}function
enum_input($Me,$c,$k,$X,$wb=null){global$b;preg_match_all("~'((?:[^']|'')*)'~",$k["length"],$Nc);$L=($wb!==null?"<label><input type='$Me'$c value='$wb'".((is_array($X)?in_array($wb,$X):$X===0)?" checked":"")."><i>".'空'."</i></label>":"");foreach($Nc[1]as$r=>$W){$W=stripcslashes(str_replace("''","'",$W));$Da=(is_int($X)?$X==$r+1:(is_array($X)?in_array($r+1,$X):$X===$W));$L.=" <label><input type='$Me'$c value='".($r+1)."'".($Da?' checked':'').'>'.h($b->editVal($W,$k)).'</label>';}return$L;}function
input($k,$X,$p){global$Ne,$b,$x;$E=h(bracket_escape($k["field"]));echo"<td class='function'>";if(is_array($X)&&!$p){$na=array($X);if(version_compare(PHP_VERSION,5.4)>=0)$na[]=JSON_PRETTY_PRINT;$X=call_user_func_array('json_encode',$na);$p="json";}$Pd=($x=="mssql"&&$k["auto_increment"]);if($Pd&&!$_POST["save"])$p=null;$Xb=(isset($_GET["select"])||$Pd?array("orig"=>'原始'):array())+$b->editFunctions($k);$c=" name='fields[$E]'";if($k["type"]=="enum")echo
h($Xb[""])."<td>".$b->editInput($_GET["edit"],$k,$c,$X);else{$dc=(in_array($p,$Xb)||isset($Xb[$p]));echo(count($Xb)>1?"<select name='function[$E]'>".optionlist($Xb,$p===null||$dc?$p:"")."</select>".on_help("getTarget(event).value.replace(/^SQL\$/, '')",1).script("qsl('select').onchange = functionChange;",""):h(reset($Xb))).'<td>';$sc=$b->editInput($_GET["edit"],$k,$c,$X);if($sc!="")echo$sc;elseif(preg_match('~bool~',$k["type"]))echo"<input type='hidden'$c value='0'>"."<input type='checkbox'".(preg_match('~^(1|t|true|y|yes|on)$~i',$X)?" checked='checked'":"")."$c value='1'>";elseif($k["type"]=="set"){preg_match_all("~'((?:[^']|'')*)'~",$k["length"],$Nc);foreach($Nc[1]as$r=>$W){$W=stripcslashes(str_replace("''","'",$W));$Da=(is_int($X)?($X>>$r)&1:in_array($W,explode(",",$X),true));echo" <label><input type='checkbox' name='fields[$E][$r]' value='".(1<<$r)."'".($Da?' checked':'').">".h($b->editVal($W,$k)).'</label>';}}elseif(preg_match('~blob|bytea|raw|file~',$k["type"])&&ini_bool("file_uploads"))echo"<input type='file' name='fields-$E'>";elseif(($ye=preg_match('~text|lob|memo~i',$k["type"]))||preg_match("~\n~",$X)){if($ye&&$x!="sqlite")$c.=" cols='50' rows='12'";else{$N=min(12,substr_count($X,"\n")+1);$c.=" cols='30' rows='$N'".($N==1?" style='height: 1.2em;'":"");}echo"<textarea$c>".h($X).'</textarea>';}elseif($p=="json"||preg_match('~^jsonb?$~',$k["type"]))echo"<textarea$c cols='50' rows='12' class='jush-js'>".h($X).'</textarea>';else{$Sc=(!preg_match('~int~',$k["type"])&&preg_match('~^(\d+)(,(\d+))?$~',$k["length"],$B)?((preg_match("~binary~",$k["type"])?2:1)*$B[1]+($B[3]?1:0)+($B[2]&&!$k["unsigned"]?1:0)):($Ne[$k["type"]]?$Ne[$k["type"]]+($k["unsigned"]?0:1):0));if($x=='sql'&&min_version(5.6)&&preg_match('~time~',$k["type"]))$Sc+=7;echo"<input".((!$dc||$p==="")&&preg_match('~(?<!o)int(?!er)~',$k["type"])&&!preg_match('~\[\]~',$k["full_type"])?" type='number'":"")." value='".h($X)."'".($Sc?" data-maxlength='$Sc'":"").(preg_match('~char|binary~',$k["type"])&&$Sc>20?" size='40'":"")."$c>";}echo$b->editHint($_GET["edit"],$k,$X);$Nb=0;foreach($Xb
as$y=>$W){if($y===""||!$W)break;$Nb++;}if($Nb)echo
script("mixin(qsl('td'), {onchange: partial(skipOriginal, $Nb), oninput: function () { this.onchange(); }});");}}function
process_input($k){global$b,$i;$t=bracket_escape($k["field"]);$p=$_POST["function"][$t];$X=$_POST["fields"][$t];if($k["type"]=="enum"){if($X==-1)return
false;if($X=="")return"NULL";return+$X;}if($k["auto_increment"]&&$X=="")return
null;if($p=="orig")return(preg_match('~^CURRENT_TIMESTAMP~i',$k["on_update"])?idf_escape($k["field"]):false);if($p=="NULL")return"NULL";if($k["type"]=="set")return
array_sum((array)$X);if($p=="json"){$p="";$X=json_decode($X,true);if(!is_array($X))return
false;return$X;}if(preg_match('~blob|bytea|raw|file~',$k["type"])&&ini_bool("file_uploads")){$Kb=get_file("fields-$t");if(!is_string($Kb))return
false;return$i->quoteBinary($Kb);}return$b->processInput($k,$X,$p);}function
fields_from_edit(){global$i;$L=array();foreach((array)$_POST["field_keys"]as$y=>$W){if($W!=""){$W=bracket_escape($W);$_POST["function"][$W]=$_POST["field_funs"][$y];$_POST["fields"][$W]=$_POST["field_vals"][$y];}}foreach((array)$_POST["fields"]as$y=>$W){$E=bracket_escape($y,1);$L[$E]=array("field"=>$E,"privileges"=>array("insert"=>1,"update"=>1),"null"=>1,"auto_increment"=>($y==$i->primary),);}return$L;}function
search_tables(){global$b,$f;$_GET["where"][0]["val"]=$_POST["query"];$ae="<ul>\n";foreach(table_status('',true)as$S=>$ue){$E=$b->tableName($ue);if(isset($ue["Engine"])&&$E!=""&&(!$_POST["tables"]||in_array($S,$_POST["tables"]))){$K=$f->query("SELECT".limit("1 FROM ".table($S)," WHERE ".implode(" AND ",$b->selectSearchProcess(fields($S),array())),1));if(!$K||$K->fetch_row()){$Cd="<a href='".h(ME."select=".urlencode($S)."&where[0][op]=".urlencode($_GET["where"][0]["op"])."&where[0][val]=".urlencode($_GET["where"][0]["val"]))."'>$E</a>";echo"$ae<li>".($K?$Cd:"<p class='error'>$Cd: ".error())."\n";$ae="";}}}echo($ae?"<p class='message'>".'没有表。':"</ul>")."\n";}function
dump_headers($lc,$Vc=false){global$b;$L=$b->dumpHeaders($lc,$Vc);$od=$_POST["output"];if($od!="text")header("Content-Disposition: attachment; filename=".$b->dumpFilename($lc).".$L".($od!="file"&&preg_match('~^[0-9a-z]+$~',$od)?".$od":""));session_write_close();ob_flush();flush();return$L;}function
dump_csv($M){foreach($M
as$y=>$W){if(preg_match('~["\n,;\t]|^0|\.\d*0$~',$W)||$W==="")$M[$y]='"'.str_replace('"','""',$W).'"';}echo
implode(($_POST["format"]=="csv"?",":($_POST["format"]=="tsv"?"\t":";")),$M)."\r\n";}function
apply_sql_function($p,$d){return($p?($p=="unixepoch"?"DATETIME($d, '$p')":($p=="count distinct"?"COUNT(DISTINCT ":strtoupper("$p("))."$d)"):$d);}function
get_temp_dir(){$L=ini_get("upload_tmp_dir");if(!$L){if(function_exists('sys_get_temp_dir'))$L=sys_get_temp_dir();else{$m=@tempnam("","");if(!$m)return
false;$L=dirname($m);unlink($m);}}return$L;}function
file_open_lock($m){$o=@fopen($m,"r+");if(!$o){$o=@fopen($m,"w");if(!$o)return;chmod($m,0660);}flock($o,LOCK_EX);return$o;}function
file_write_unlock($o,$bb){rewind($o);fwrite($o,$bb);ftruncate($o,strlen($bb));flock($o,LOCK_UN);fclose($o);}function
password_file($Wa){$m=get_temp_dir()."/adminer.key";$L=@file_get_contents($m);if($L||!$Wa)return$L;$o=@fopen($m,"w");if($o){chmod($m,0660);$L=rand_string();fwrite($o,$L);fclose($o);}return$L;}function
rand_string(){return
md5(uniqid(mt_rand(),true));}function
select_value($W,$_,$k,$ze){global$b;if(is_array($W)){$L="";foreach($W
as$xc=>$V)$L.="<tr>".($W!=array_values($W)?"<th>".h($xc):"")."<td>".select_value($V,$_,$k,$ze);return"<table cellspacing='0'>$L</table>";}if(!$_)$_=$b->selectLink($W,$k);if($_===null){if(is_mail($W))$_="mailto:$W";if(is_url($W))$_=$W;}$L=$b->editVal($W,$k);if($L!==null){if(!is_utf8($L))$L="\0";elseif($ze!=""&&is_shortable($k))$L=shorten_utf8($L,max(0,+$ze));else$L=h($L);}return$b->selectVal($L,$_,$k,$W);}function
is_mail($tb){$pa='[-a-z0-9!#$%&\'*+/=?^_`{|}~]';$lb='[[:alnum:]](?:[-[:alnum:]]{0,61}[[:alnum:]])';$ud="$pa+(?:\\.$pa+)*@(?:$lb?\\.)+$lb";return
is_string($tb)&&preg_match("(^$ud(?:,\\s*$ud)*\$)i",$tb);}function
is_url($R){return(bool)preg_match('~^
			https?://                 # scheme
			(?:
				# IPv6 in square brackets
				\[(?:
					(?:[[:xdigit:]]{1,4}:){7}[[:xdigit:]]{1,4} |             # 1:2:3:4:5:6:7:8
					(?:[[:xdigit:]]{1,4}:){1,7}: |                           # 1::                             1:2:3:4:5:6:7::
					(?:[[:xdigit:]]{1,4}:){1,6}:[[:xdigit:]]{1,4} |          # 1::8            1:2:3:4:5:6::8  1:2:3:4:5:6::8
					(?:[[:xdigit:]]{1,4}:){1,5}(?::[[:xdigit:]]{1,4}){1,2} | # 1::7:8          1:2:3:4:5::7:8  1:2:3:4:5::8
					(?:[[:xdigit:]]{1,4}:){1,4}(?::[[:xdigit:]]{1,4}){1,3} | # 1::6:7:8        1:2:3:4::6:7:8  1:2:3:4::8
					(?:[[:xdigit:]]{1,4}:){1,3}(?::[[:xdigit:]]{1,4}){1,4} | # 1::5:6:7:8      1:2:3::5:6:7:8  1:2:3::8
					(?:[[:xdigit:]]{1,4}:){1,2}(?::[[:xdigit:]]{1,4}){1,5} | # 1::4:5:6:7:8    1:2::4:5:6:7:8  1:2::8
					[[:xdigit:]]{1,4}:(?::[[:xdigit:]]{1,4}){1,6} |          # 1::3:4:5:6:7:8  1::3:4:5:6:7:8  1::8
					:(?::[[:xdigit:]]{1,4}){1,7} |                           # ::2:3:4:5:6:7:8 ::2:3:4:5:6:7:8 ::8
					fe80:(?::[[:xdigit:]]{0,4}){0,4}%[[:alnum:]]+ |          # fe80::7:8%eth0  fe80::7:8%1     (link-local IPv6 addresses with zone index)
					::(?:ffff(?::0{1,4})?:)?
						(?:(?:25[0-5]|(?:2[0-4]|1?[0-9])?[0-9])\.){3}
						(?:25[0-5]|(?:2[0-4]|1?[0-9])?[0-9])
						(?<!\b0\.0\.0\.0) |                                  # ::255.255.255.255  ::ffff:255.255.255.255 ::ffff:0:255.255.255.255  (IPv4-mapped IPv6 addresses and IPv4-translated addresses)
					(?:[[:xdigit:]]{1,4}:){1,4}:
						(?:(?:25[0-5]|(?:2[0-4]|1?[0-9])?[0-9])\.){3}
						(?:25[0-5]|(?:2[0-4]|1?[0-9])?[0-9])
						(?<!\b0\.0\.0\.0)                                    # 2001:db8:3:4::192.0.2.33  64:ff9b::192.0.2.33 (IPv4-Embedded IPv6 Address)
				)\] |
				# IPv4
				(?:(?:25[0-5]|(?:2[0-4]|1?[0-9])?[0-9])\.){3}
					(?:25[0-5]|(?:2[0-4]|1?[0-9])?[0-9])
					(?<!\b0\.0\.0\.0) |                                      # 0.0.0.0 excluded for URLs
				# domain
				[_[:alnum:]](?:[-_[:alnum:]]{0,61}[_[:alnum:]])?
					(?:\.[_[:alnum:]](?:[-_[:alnum:]]{0,61}[_[:alnum:]])?)*
			)                         # host
			(?::(?:[1-9]\d{0,3})?\d)? # port
			(?:/[^\s?\#]*)?           # path
			(?:\?[^\s\#]*)?           # query
			(?:\#\S*)?                # fragment
			$~xi',$R);}function
is_shortable($k){return
preg_match('~char|text|json|lob|geometry|point|linestring|polygon|string|bytea~',$k["type"]);}function
count_rows($S,$Z,$w,$q){global$x;$J=" FROM ".table($S).($Z?" WHERE ".implode(" AND ",$Z):"");return($w&&($x=="sql"||count($q)==1)?"SELECT COUNT(DISTINCT ".implode(", ",$q).")$J":"SELECT COUNT(*)".($w?" FROM (SELECT 1$J GROUP BY ".implode(", ",$q).") x":$J));}function
slow_query($J){global$b,$He,$i;$h=$b->database();$Be=$b->queryTimeout();$he=$i->slowQuery($J,$Be);if(!$he&&support("kill")&&is_object($g=connect())&&($h==""||$g->select_db($h))){$zc=$g->result(connection_id());echo'<script',nonce(),'>
var timeout = setTimeout(function () {
	ajax(\'',js_escape(ME),'script=kill\', function () {
	}, \'kill=',$zc,'&token=',$He,'\');
}, ',1000*$Be,');
</script>
';}else$g=null;ob_flush();flush();$L=@get_key_vals(($he?$he:$J),$g,false);if($g){echo
script("clearTimeout(timeout);");ob_flush();flush();}return$L;}function
get_token(){$Kd=rand(1,1e6);return($Kd^$_SESSION["token"]).":$Kd";}function
verify_token(){list($He,$Kd)=explode(":",$_POST["token"]);return($Kd^$_SESSION["token"])==$He;}function
lzw_decompress($ya){$jb=256;$za=8;$Ia=array();$Qd=0;$Rd=0;for($r=0;$r<strlen($ya);$r++){$Qd=($Qd<<8)+ord($ya[$r]);$Rd+=8;if($Rd>=$za){$Rd-=$za;$Ia[]=$Qd>>$Rd;$Qd&=(1<<$Rd)-1;$jb++;if($jb>>$za)$za++;}}$ib=range("\0","\xFF");$L="";foreach($Ia
as$r=>$Ha){$sb=$ib[$Ha];if(!isset($sb))$sb=$gf.$gf[0];$L.=$sb;if($r)$ib[]=$gf.$sb[0];$gf=$sb;}return$L;}function
on_help($Na,$ge=0){return
script("mixin(qsl('select, input'), {onmouseover: function (event) { helpMouseover.call(this, event, $Na, $ge) }, onmouseout: helpMouseout});","");}function
edit_form($S,$l,$M,$T){global$b,$x,$He,$j;$te=$b->tableName(table_status1($S,true));page_header(($T?'编辑':'插入'),$j,array("select"=>array($S,$te)),$te);$b->editRowPrint($S,$l,$M,$T);if($M===false)echo"<p class='error'>".'无数据。'."\n";echo'<form action="" method="post" enctype="multipart/form-data" id="form">
';if(!$l)echo"<p class='error'>".'您没有权限更新这个表。'."\n";else{echo"<table cellspacing='0' class='layout'>".script("qsl('table').onkeydown = editingKeydown;");foreach($l
as$E=>$k){echo"<tr><th>".$b->fieldName($k);$fb=$_GET["set"][bracket_escape($E)];if($fb===null){$fb=$k["default"];if($k["type"]=="bit"&&preg_match("~^b'([01]*)'\$~",$fb,$Nd))$fb=$Nd[1];}$X=($M!==null?($M[$E]!=""&&$x=="sql"&&preg_match("~enum|set~",$k["type"])?(is_array($M[$E])?array_sum($M[$E]):+$M[$E]):(is_bool($M[$E])?+$M[$E]:$M[$E])):(!$T&&$k["auto_increment"]?"":(isset($_GET["select"])?false:$fb)));if(!$_POST["save"]&&is_string($X))$X=$b->editVal($X,$k);$p=($_POST["save"]?(string)$_POST["function"][$E]:($T&&preg_match('~^CURRENT_TIMESTAMP~i',$k["on_update"])?"now":($X===false?null:($X!==null?'':'NULL'))));if(!$_POST&&!$T&&$X==$k["default"]&&preg_match('~^[\w.]+\(~',$X))$p="SQL";if(preg_match("~time~",$k["type"])&&preg_match('~^CURRENT_TIMESTAMP~i',$X)){$X="";$p="now";}input($k,$X,$p);echo"\n";}if(!support("table"))echo"<tr>"."<th><input name='field_keys[]'>".script("qsl('input').oninput = fieldChange;")."<td class='function'>".html_select("field_funs[]",$b->editFunctions(array("null"=>isset($_GET["select"]))))."<td><input name='field_vals[]'>"."\n";echo"</table>\n";}echo"<p>\n";if($l){echo"<input type='submit' value='".'保存'."'>\n";if(!isset($_GET["select"])){echo"<input type='submit' name='insert' value='".($T?'保存并继续编辑':'保存并插入下一个')."' title='Ctrl+Shift+Enter'>\n",($T?script("qsl('input').onclick = function () { return !ajaxForm(this.form, '".'保存中'."…', this); };"):"");}}echo($T?"<input type='submit' name='delete' value='".'删除'."'>".confirm()."\n":($_POST||!$l?"":script("focus(qsa('td', qs('#form'))[1].firstChild);")));if(isset($_GET["select"]))hidden_fields(array("check"=>(array)$_POST["check"],"clone"=>$_POST["clone"],"all"=>$_POST["all"]));echo'<input type="hidden" name="referer" value="',h(isset($_POST["referer"])?$_POST["referer"]:$_SERVER["HTTP_REFERER"]),'">
<input type="hidden" name="save" value="1">
<input type="hidden" name="token" value="',$He,'">
</form>
';}if(isset($_GET["file"])){if($_SERVER["HTTP_IF_MODIFIED_SINCE"]){header("HTTP/1.1 304 Not Modified");exit;}header("Expires: ".gmdate("D, d M Y H:i:s",time()+365*24*60*60)." GMT");header("Last-Modified: ".gmdate("D, d M Y H:i:s")." GMT");header("Cache-Control: immutable");if($_GET["file"]=="favicon.ico"){header("Content-Type: image/x-icon");echo
lzw_decompress("\0\0\0` \0(\0Z\n|\"ј^=HdR9\$M'J\$hV-9K%\0	)NgS}?P@`:^\\2-K T*VWVdRDM=e	{F-KMjo\\hRD/~%kd^V.KR՝݂bqX9/c\neԳ4B\0=&G/K3/5XX4۽^UإaDTegeKާVu/6ߒT{ը@r>	/]b\0VܼOsrJ@b^>>aiP\nN%^q%	xx)\n:bAaC*T0ic)b'x	y,AhGX%*ZS<.T/j^kH)x_'xԗP/.\nBiy#F)7@I`*iy7Saʗ\"\0HIDu%t{%K'xiL9(%_A:4UH-G/X_<W=ixO@B;|u\n^`6:^t%\"^襏`?%\0\0-Zȥ@!L)at\n\r◎iyҗbX?xPix|d%JX>p(s2(^^'^dB*NXvj~@@y_pI\"_I%nI|J^\"cgahsR^;IxƔu*^o%vy%:XJ+Ua%pI2^C%z_>id[%Jn,wؖc;^h%p?y/aq[k\r}O%֋tXإ8z;8k֏i`9֒+.Ic&*^IvZp	ljdKKJ%HX!88@f`I`%QrX-G\0K	//BXyD\0ļ_?<'!X\"/H֒˔:\r\$v\$j'KǢ,İ)\0Zhh5KG&aKɉ,a<BAIxu%ᄗH8-E bI`%_d\0-JZ,\nT,wK:Z7)I:K|2XSD%Uʠ[+iҺX_ R^q/%\$0DDV;AhF҉6r0-h0fݛ⬗^RA/\n~pVKLSzlCq/\n~?/3B|\$TI%qIccŻ\"Bg&BX.y,ld\$K-nhNK(I9|ؗ^(!}.EgBV-+<Y9R\\uULh,dRIxf-焺4K]\nPRi,?9+,fN*w@Z HhV\"F`k\$w\\-sBY\0Du5`	*ig8_E!ơL<`ΝD%HlEQ!:\r~?\$K7D!q`5XUwIІ	xsA<Ka/ʖ@q-P^Wk-@b\"B/\0Q󰚨}y,dKp-.e1s	.%]0jjKA/1H2_\"kۛ3n&3`ضA(3	`,Hۡ%LxiG>u\\-6,6Mz\\Ϝ\r\$(-q#	2<EAhKjıȢ.	\$^rxx-+:X-Zw<O1.Ue(-?/0ZۏDpjZ^ZZDf݌GxA,_L ZAhYSУDK+TYYkt2p&_`57lS\"K,Ǆ#ɛsT\"5 Ak#ƣxľЙxn@`(/`Lܨn \$Kf,IUV߬藊_KDŦİ=B_AAWN,`vnKT8v^xiSvßjk%̡SZ&z}if=_\"\r!@^gAyoM]-_?ZwZKZﻞ̒|?Cx\0\0@?<x?\0?|p?CX//o`~\0!p0~>Ͻ}]/\0!'kj\0k		p	\"j|\0\0a\0/x\r o/!#\0q*Oo|\0\0\0P\0\0\0a\0a|");}elseif($_GET["file"]=="default.css"){header("Content-Type: text/css; charset=utf-8");echo
lzw_decompress("\nCo6C(\"#Ha1#yd1٘n:#(b.\rDc)a7Elñi1Ύs54f4ngsIhMдi:`,]YtL0hD*B0\rF&3xs'[Ʉtv4S%0XLW5)Yf\r^=~9g0\\@rQNn^yNj{opC%ʋGSZh5Z|>:'b{J)Ɠєt1*uS=^2*8t(0R,8j:x@9\n@1\nJ#4BRJFƋ>#J`HaahbC0\r4Ar&\nB54\$>+QA2DoMEL\"48=s5DLW7JGf**HjEK16ڸ,oLtJA\\\$Q|9-H@0\nxtV(o.+ܮ;1D8e*c\rT䍣B2܍z\n83=Ktƻu(kmׅ.G;+:2)cn<s5:6\nԡ)_\\6YL\"VV`c\$L;k&\$?XAWU48	Bޡڮz*[O24<?{36%;VV:\\A䎈	xnpxF<[xoW.U[Ãsd7rF&	bÒ]t*7ji=dZֹYy4:ieup\\6bHCxf׳Ɓ䎁sr8KrJp\$|;-9(?O2zĐߋO~o(;{]d%&Dy8EaM&\\ta<\0A8s@NC@(Y=OйҞB6x1]k44\"b(`A;8c<eBw*\\B٢0\n0 /ll˩\rC_*2~X-I\\ybfe@`u\"̆5hs@T;>Cphk%'\$ᰂI;R|`]FB\n.[r2/`\rҢ\rCKeF2[r%)Y,5&ڸpMe=(N@+9e8fnu:܋T}ԎGC\rNsg%>ÔP6Hʒl?τ_>hee,3F n9eFhaM),_#a-HiB-(vb&rJ1HhUiy\0#SM˵IS`-MTV}\"UH,  #ֵֹ;-\"ы\rt2\nFLؖu-5S_+y50Q/3E|%}AC&tGk2JiokbHjQQ\"x_B<A8'ṋbVx[\0:(ڃp)Nag(6#@d8w?l.H9ޫF~!%D-&geaZrr̆%aPMV>mq\r1P	ę-tZ :lx5&PZ6pfDg)pPLA,\\\rȮ7j1Hۿ.r&AdDHJTlɆJ @8\nI)Yf`<]fJ@8kW1v3\$k\$3v8:{}r.IiJ,nR@ٔ^AyeUpҢ:ӇkZV9[zP@{T;VA>Y=e97m^6[D\rDAp@[:*ee;pVi@!0` pN`	mnPh8^g0e/*伟Y(h.<@Pxx\0dt1\0r6ӈpPt<@~34a|{ \0mT]ht dA.1j7 RWwQ nEȾ eK`xSz׋%tb\rh3@ӹފ\r2\$0o04\0xԌ\r</`<Ex_<P1\r%up0-n!0PtPa>}`fzw@RWgZ#x6x-bdrOvin0\$&\0`P\\J& @&Nid%΄/bdmqrnE\r8d\\/\0N.\r^O@n,#D 褗	@0o\n\"^/lrc\0D/IPȭpc\00NP\n	`[oNE\rn@pfnP΀AoF2(l@VP(nI`bd pn0XHPhOOxbaϳ(znQΊΐ	`fd^%P\0dp/(x`BQ^@09^[ȯVo\"O@0. 2%V\0 jrR?.CΖ=\"W^P\rFe\$\"c nxQ\$Q nO@z `D1y	c%`nP,,`pqPRzz02D.Nio#+0X iI1Բ1grDD1)1np\"WҗΒ^\\@\r؄\0JdrV#ζ(@^>Sc6`N3x|jp?vCs\r~1epNn\r/Ai#L98%@1@O8<\$ҿ3Z;OOE@<3!Om/ M0&AlEo\"\0@%#6E50L;&6\r@*ToA3p>^`pR\0#'tT@b\"TJBhp\\SG+@Ps?C<%<E\$&:dFo@O	/#D\"aQ5Q;\0003CP\$ba-p[.	ogCDU΃1UR%Vn\"HnoDe:ϿCRR5wRuLfq_SOaNyO8R@=.uQ(/Bdi u\\OH\nZC{Ok	o[1!Pҭ&QQ4/^P+lP\n-`r,V2zr;U\npA4=W^2NdP,!PP	,Oi`cT^ҽ!UND_pHnS^TPHlϠSum1EbhQ01	 b!. PA*qQSϧ\\5M]kQ`Rq[nXQRLWc	1pȠkd@i̏qEOL#mUownqO4OC\0qc_yNpj\r1Ѝfe\npWw(N-z5<no.uIuwWh`cuhwIv\0nRC6t\nr?2hfO7jcir\"rou1*хg7\r0BbROuqV6o'e2&X{ϥЩq%0\0gzc{3`\r3e6m:suMM\rHI\0Is99:Ss:{A9z8G4v\0O;ύط/It\"/{uO{V;W\$KttP\0j)eEFyq}ؽB?)3gnt5,9CMZy&u- WwqaE.jFNN`ېpp@gvY&Y_DUU9}P=IYyI` D\"؊\0*PS(``JXb^KY>0y\r9>43++-Q5hԎK3ICGm>CL7-ۺt]\rխ.V-ۦmC\0N*; vu XB`zNn`ɝD\0V7\nplERVc9.HN.Rp@D#;:Zӱ>L:\"bZ9:;#:q;x㫧x[Jy?{%'4\$@Qn\0xɶ[Xǵ\r/sidC\rnƗew[ivQ{{K`,q=N;zѾՙ;0 m[9O@Gp\0pF3b#Bq\0dbKGH]b-ݥ_ĪI-yţM܃!Z:LZߺ.)BխZ߮A-Xi\n)|ǰmSAHMAr%03}E8;T\\\0G[S{<_ϻbi΁;wA _\0uo,I/-Aw]OĆDuqn&O-e`E}\0PCj\r}iqSRf(DD|/\"zN?\$\rd5=ĚogmMŧ2MhHFi	cNC\$_nEztꜗɺɬZ:׮O9^'˜ ;	<ͭ.jsfg|ϲT\rл'/<6}2Y]8ka\"?;]m[p+>;+9N[6QosnH;ǹϰH>;	uu}Le껢d/,/#\r1I>{_[˿\0=PFlHxWt1(RerVJ,*T?'Rp\0?2L`'p_e@u9#|?F>ɴv<zRS?d6@'i̾O\0F.B׾UM䐨pj]\r42mF4Aq&`01|cgߒ剸\0jIz_셧oN.VAl\0XkfFSKMPlF\ru\r.L>hCCIW&?+F2Q	JPVX	d\$9pv\n& 5V\"؟ð8\$*iEf,g,5DS\rh<%\raM	*MI/vg?ph`RQrľB:hY2e\nbp\0y4ZN\0T|}Gn8iHv5܎*0{ɨ0}\\%OAnS\raL4Ɏ=j՗9 Ok|-ixkܮ嶹H.\\kXa`Y\noSS7Ms`N-0琅=)o;mK:!箊z\"&Q\"6ҍgZ;֛w\n%͊o\0ٖ\$3LD\rOu%-ΊX\$)Mo\"Xܣ\\12*l.n6yI[y\"\$.%g:<M!b'ۋsޮ\n&\r҉l]b>\rCo\\!\"7AZQg)c&pFZ2'f21lP\rrP0\nhR}F6AM\0007mwjᑖƉD58 X2/#c@%ذq_cHf\0*,u> ;îx\0xP'X 1\0?G|\rqd+q(xC~S8\"B~p	efm`)Q*=!!bP[QSFr\0\"\r|AhXM\"(@*;m(dz+x}y\00022vd\0\"IGd&h*cfH-M!EH1ےđc[Ry'	NQ\\@<`\$");}elseif($_GET["file"]=="functions.js"){header("Content-Type: text/javascript; charset=utf-8");echo
lzw_decompress("\nB9 3NG89e6Ms@sLgCy '#	.t9MxC#d4Ebef0MC9=7γrNFm8Dx(u7F&(Cq`d:OAH\n*AχE*)NSR;AP 6a0A#M	4k7֧\nF7iuuU)~tNf̝+mnw[\$#(Սu^ƩNeq]\rhb.886\r\nBiZ	RY	6Acv*K'\r4b,K#9{\"=Kñ,[Ǻ= ( \n:K\r(@7H]-䘅R.tk2L#2DaOֺ8P3\rR3a\09\$\\0<r6-t91@b/2E,3JTu-N?Q[M>,ܪJ:Ot1R3SR\"#D*5ʹ_;z]=3c-C݃EFsmH\r0=>3t~<u;O6-MTUPE7lk__8'\$gX7ݍXHV}Ø4ꣾ61j(9\rxީV7 1\rONjFJ6#Udj9ci_{LXʋ%H˳`H鰋{pZ`˼J2Q;R68@!b68\n\\b-Cx6d^@@,s	(ʶCćH^B}d<}\"*0Z\"P.N|M_cHJwwlAϟ  OT\r3Hb\r):.>Qк0ʺB#.Ui爍޸#+/0zy;qI￠NAD7@VFaegkLǮSWQZ=a5B_\n6#\rg8(	ox<hd!X16/M@\\Uΐ!DIj]_zb]MLGw	٤z)g\"♝\n1b\"ӇkLr.t.bOcXw*T)Nh:tm/吿\"DiRU1#!]/dnc5ҍ#T\$8esMϧeMyaͳBp`E%F0[+%+K:HƎ'd\nYK\\XSd\$V=5FFI]\rT[#`ɔ2&x\r˕M4FTM?/d\rHZwJ2pp\r0&\$q%\0&x\"Z: EPM\$cEOH2#EKMiV)q\\%'QFV\$#P(^ѩyGT;)<OA@.`Fݥ\0000yZE,N	\\SPnhg{]kxCPa\0qJp?LmZJ:]IN	^^0pUpfIf7&Hdl6@QKR@}[e˛&1ѭLTthV@-(cv1QD\\D5'XbؤԹ*\"(أRa+5D*: JCA`Yw%E^|h蓴]%R;KAZA\\S\".XldKÍEA72\\^-Aّ0\n~=APAB='8^zPJpR	-'\r4#-B\n..\$3^>1K<@ŪOgӄkO.>ݖ*4&-XPP\"Lju\$ek]\\:5k^ל_CeqdM\rω *ry̭+g6k.k׻L_HׯPRc[Yr-\\]~C&\\зx@''ogb0( 	j\0o2A	d޵gY\nX\\@	LaJf\"ido;pu#44pÙBfWLb]Hd#@t\rS٫^%@'	~\$>ט^sp!rd`@9m?^uOS	qx0CZnc(!)̠..:\0<\0҅lp(\"@?IR\r VkNn`~#\r,X`@`kL!*d`~<\n npm.A@\$ҰmiǪ)l9lOZ!	.tL,'%:f\\0(P)p&4?2\r7weRvM`@ׯ6pLOpzQCPQ`nnq\rJg	di\0(v`zQ,\rpxLJi]\0;A^Opx(E!Z(&0*#yi%yQ>\0,.\",ާ:rlNpOo/<¥8wFo&1^\0AFC	ʓ\nP[bސ-hK#p[.p|<gjl1h^`ڹLpmPQpvmn\"?2\0^:fD*FIro̑P_\0tD!'iuo\"u瑐6\0l2\"g`mQ-Y<b,,z}(\0\rgL|\r@23):F\r-4r\0. ևSH*گa+ŲH9W\\F`AH#V҅e6 \nh&\"nS@nS=&q @3ڷkPۨ+Bft x 08.@NJJӋ H7'\$ZQ\0Bw\0^qP\rW8lJ(`DMQڷ|S1\r!G\\ĳ8N-*Q/  AD3+ w4J.?^f`A\0&\n1!*_ b0frDD\0^R}(؅`qKe4,!ML\rKr\rN2m(P0g`JĽAķ|'#_i,E,2%жCr5JtT\"T,+GsD)wGpˤu@m\0CS578@4U5S_K]XR][HuZU /%~7PT0\nFly4`mfLCZuSt'ѯRQ(o]E?0S5[>Ս_VptA150*?T3)beh~<I=cnBj Ġ\0,#d8S(CgD>DԷvg]VZF?JCc,K\">1܍B76]/i ,[/pOxڨw/|Qc^yBUD}L~gphEzlVVe@M4E{n.<:1\0D3\ryjiWKu7V6_t9eMtB܊Lɀd\0Mb\n:7;&W|Sb3GL\nh\"nr8|28\"]Ђ̔7BAkimG}~\0*\0-Xe{<b	Q֘))U'k逫>MT?ψM}J?nȏ6Bn)	\$,.EAVJvWt/<00F '>8]G£	~ DxD}	j?x< b<\$¢EXرiqحʵw:	TMO5F0e9xnFr	j}#@OpV4b!j8gCo:u~x9@\nJߒK{Jm;E3Cx\"Rte5nָ%ԯ/!GtE}K-2%i/L=/G+Cqr}&0Xٶ#r)6yj Z@P`^}*9,͢?9Q-'e3'2\r2ѱر6!≤gYhuabot	Tm4CRWa?ڋ]8O9cLCHM,Z`*J`#F A!**0I~\"MYt\"F2ѕ\$a]Za62ѮJ\rzbu\rеbupWw{`e,l˄Eytuh>S\"h*5C! à;695q9l;z9h1b4Hē_lU\nXFg(N)rG	h0'W%{j(s;u{P\rd#Yzz\$<OBf``.\$ZǤ2z5R#rHCv, |/{Kڧk>Xh;yĠ\"#n,if\r\nHKٻ\0{6({\ny|\nn\nh_v\"Gpb{N0άA-,p_c+ygh?gyY1]BeUHtGdf|(3\\v\\@h|L|m\",pT<ZqJ`EfZ\0P\0ڋvoZ\0y73_宀´VdDE3E{;<'Ez+\\îBJGSIR5wUZ:ZF;Nb쵽8e`A=4n>Fvwn4-`E]Z#)w?qo\0A߮-;2pt ;\rB68#O<0S ӽ0X{1f \\\rOD\r\0*×\"?z=:aZ;\$)ɱ\"~m3H?>47 an*]De{Ȼwnt44Y0fL=Pe)MFaӔ7|]<\"UR\$KIܐm[T3Sog9Z72Z羋mT/1N~}T=)h{^}Q_70_;&v\rk(\r\"\"iq\n>`vL  ]xFDЃ#kA<֝H-Zt@q>*x8\n@qEDy#]:)xߊBƶ#&S짪xq~tre{v+zƕ퍰\$&P[`aOw}{-K֠~Z%Ms^v셌Pe^AܲG]JNuh=GE:AȌ|(>=ICQnb漥:/f(\nQA1ra\"n=P]2#>.t\n߲Ћ;Q\"{aSf1R_T-g8ErD30_ǜU*lܵbf6h姇*[K48ixd\$\0k?[	CϘ.Ú,eH9-X֠a	b=P~\0Xz~h 6FxLm ,CN<Br8;Dm3ILHaE @LVat j\$LH sBb&_(!\0>)Ǣ\"H&VH!QH~J@(@<M l͗q\nd]\0	|oP	5(6hp2P9	\nuJ'A\rƃJw>5i1ёìeVN1uf5(HFXku(3F09Ylb(C\\,/قS^+1	?s6\"͢orJZ6&,\"%QJ;IQ4<#n>\n_)r!¥js\0P7,HS\\o{\0Gjl1HqA4\"WXC#`CI 	BE8ڝ:±/a! `Yx(]K<ID0Ex8v!灬+igJ6ZBBcBrJȆDh>#dQ	H*D\0 J\$ PXB7%Sb\nzL@e 6=p&idU\$\"@*@~dtsW6+%H\\/ZHs9hr:C%6H.%va6(p>!\"RdEF>QCeS(YKxt)Y[>ZD.|I{m(\\ +\"ȆD\nIe1aP`b#@	Sp\"u0s2 -\"`tC\nzN\\bvSh| \0-'D\"2dIwzXl-2W!vy!p\\Y͈	F[)ȀSmɖ6dа  >YDT)i[SA]d&C3g(+!\\r&STEZRFeH,JyUJ/Q++A,W\$d7P!2XNX%2	i`]r\\̵53VEKo=\n*\0J N6i~_\$:wa8³Ah9XX ǹl&e2G/񻐾Ip叉;'7S>|f(XRC!&99˫.w	Nn|8(Y\"G1!8?CH Y]U<@!u:~gYdWf	o}G~#8SnIF#\"90>X\\TGsR~Xb> ϊ8ʨ@4)Pihv\"B5\$,h3!#>MlCO@(\$qy¢f%V\nѷR>c\0Rh{(C\$!(d{cn\$WЊa`jx0D OxC1T5_<.sҐeSϞ}|p.\n?r\\Te- gBJjKpyLP4\0`P\0S[Q9FReN6צe!'gy,1>3a>f0H!(~\0B!*hǚ1&xԆż1{x]0ՑM\"]L`7SYS5/BULߣ'iA\nY}S*FBgzY@\$g\r)X\ncu<.Q̂DQq2K\n:ZtUţq<	2Ub\"5??-Apޛ2lڇA;Z-*@\0)wڳ]BgkNwȽȾ&9!\nEꦘ@U\rfRj] 3`	Q\$s6̷1sZa#&T,`	Z^M`9cTظW!BA3x{\0wl 4!}A\\к!LH&!F%3b;tT\nt0Y4]'{7p.U-39\$oj+y7nyL|c8\nLdJ`oUuv6ܳ0ZhAIO#(r/2NʮDYYWqYP`X`u0c'm\n9]k]mm%{2Yp]lfume,=k9&FyN,GYP\noOT/Md}5L`ZCDj`)a(P1K⎦S̸Q'a/	U{Qi˱<MX#Xrck	Z01X<P	)}!yte\"k ~W4Xvͱtv'*պaU}ckYVZ=̠l1lDL/L،z^a-Cc.~0^b_{F:}H\\[:) 2t`ha71I֖PZefmBT^,2Y	`hqsg1>Mpsє1>%GnzyN紳e-SYۄIHYͮǹWka iAsD5|=Bȅ{4H<FPh/Vnc˪ɣ=`xOϋ%YPTS4\\4|6郮ZY(f},#ǀ<Z?/7lHjB_p`;ei\nu1/!BA1VV0Q2hx\$47!=)EV669m8Z\r6aX\$Ra7zP@02?\0N97<)hvG6di?4\\NI}@W*\03𕣱#wq_X1Z(O	)D՛1K,Z\\!vgxI{V*L\"\r/7뢹D\rgQW0*\n\0\$_z5\"&B'з1޺HPΐ:Z}\r~ꩅi_ PƃL27XjF^#l,֞8BÒ@PАSGhL>?}ܕ{U-HƕUC/7&(/\0۴Ț~-	+3\0le\nr*\0*;Cv:̰uPqnR@u[Pwa%.>Y2Tzh`%-d8yV^\05-pQ\"R\"	dZ=Cl<]2׷aAbK\rPdD3oU~`P,S\nyC(^QF`RB̖%2/(\n`q?d]FLrg\\'D҈rEeѫ[)YLA|@±7\$+ʂt;:1<yLOVnԤe{,	Ҥ^ WXr̒\"`a	S`~Z,)+L̀\$'lK\"?ua!@&xACNo!˲VSoM>8:C{~C/@!(Ex\"b]y~H3f/)47Β 9pP; yOrEmWnkdFقQ`V!9l0b.Q'n|i'HK2#NuQ֯S?!73회#@]x}YYqS b{e@ϩ4J%Kz7hRjD(	Wbm car'AHtS|nFd/Vcq0\\	Lo#/##є֬e\nE	/f(Du֪YD8!\\)ӠY5֒f3Heĵg%cG:PiXZY\08D_UX6Tg6!E\\k&\0R9[ػt57ŘAV(iS|r1_	=뤹CC}tD'KWk6b6 Th5f?Bq{0<5j(5s&<699s\r_Fc\0	FM5pިmB^ #RB\rJB0cKC_]Λƻw\n?ՄeJަmD+|fg3\$D~%#:6ojhoڞm}D0;ٵo}l(߲V`0fXӡ	#?( 3<İtN66ȵo\";Kqk8CṆHlZtSO&u7\r\rz[\rCuJu18-\n78f2#+5,zD:c\$m,zRjQ6w\r1hPݖdU	G?wA~;tMCe\rg4rn`t`4|Sŵk}+*Wp=ؠl`ɼ?+uJ{2Z@{x>7~zǀ'Ե%L[ůҥ aįdn\\89v2[@LOg_;q8]Nuba(Z=54ݣ0Pn,[qA>I]WºЁ'ݯ@Vu(uחQM۾kQ(p#TkhhC;N:nW\rMN3#|bic*&YJ_R\"*\08>Q@iN׌47ED38.4㍯7\n(&߅zvh#1r\$)x&]>ʕ");}elseif($_GET["file"]=="jush.js"){header("Content-Type: text/javascript; charset=utf-8");echo
lzw_decompress('');}else{header("Content-Type: image/gif");switch($_GET["file"]){case"plus.gif":echo'';break;case"cross.gif":echo'';break;case"up.gif":echo'';break;case"down.gif":echo'';break;case"arrow.gif":echo'';break;}}exit;}if($_GET["script"]=="version"){$o=file_open_lock(get_temp_dir()."/adminer.version");if($o)file_write_unlock($o,serialize(array("signature"=>$_POST["signature"],"version"=>$_POST["version"])));exit;}global$b,$f,$i,$mb,$qb,$yb,$j,$Xb,$ac,$aa,$rc,$x,$ba,$Bc,$ed,$wd,$me,$ec,$He,$Le,$Ne,$Ue,$ca;if(!$_SERVER["REQUEST_URI"])$_SERVER["REQUEST_URI"]=$_SERVER["ORIG_PATH_INFO"];if(!strpos($_SERVER["REQUEST_URI"],'?')&&$_SERVER["QUERY_STRING"]!="")$_SERVER["REQUEST_URI"].="?$_SERVER[QUERY_STRING]";if($_SERVER["HTTP_X_FORWARDED_PREFIX"])$_SERVER["REQUEST_URI"]=$_SERVER["HTTP_X_FORWARDED_PREFIX"].$_SERVER["REQUEST_URI"];$aa=($_SERVER["HTTPS"]&&strcasecmp($_SERVER["HTTPS"],"off"))||ini_bool("session.cookie_secure");@ini_set("session.use_trans_sid",false);if(!defined("SID")){session_cache_limiter("");session_name("adminer_sid");$sd=array(0,preg_replace('~\?.*~','',$_SERVER["REQUEST_URI"]),"",$aa);if(version_compare(PHP_VERSION,'5.2.0')>=0)$sd[]=true;call_user_func_array('session_set_cookie_params',$sd);session_start();}remove_slashes(array(&$_GET,&$_POST,&$_COOKIE),$Mb);if(function_exists("get_magic_quotes_runtime")&&get_magic_quotes_runtime())set_magic_quotes_runtime(false);@set_time_limit(0);@ini_set("zend.ze1_compatibility_mode",false);@ini_set("precision",15);function
get_lang(){return'zh';}function
lang($Ke,$bd=null){if(is_array($Ke)){$zd=($bd==1?0:1);$Ke=$Ke[$zd];}$Ke=str_replace("%d","%s",$Ke);$bd=format_number($bd);return
sprintf($Ke,$bd);}if(extension_loaded('pdo')){class
Min_PDO{var$_result,$server_info,$affected_rows,$errno,$error,$pdo;function
__construct(){global$b;$zd=array_search("SQL",$b->operators);if($zd!==false)unset($b->operators[$zd]);}function
dsn($ob,$U,$I,$F=array()){$F[PDO::ATTR_ERRMODE]=PDO::ERRMODE_SILENT;$F[PDO::ATTR_STATEMENT_CLASS]=array('Min_PDOStatement');try{$this->pdo=new
PDO($ob,$U,$I,$F);}catch(Exception$Cb){auth_error(h($Cb->getMessage()));}$this->server_info=@$this->pdo->getAttribute(PDO::ATTR_SERVER_VERSION);}function
quote($R){return$this->pdo->quote($R);}function
query($J,$Oe=false){$K=$this->pdo->query($J);$this->error="";if(!$K){list(,$this->errno,$this->error)=$this->pdo->errorInfo();if(!$this->error)$this->error='未知错误。';return
false;}$this->store_result($K);return$K;}function
multi_query($J){return$this->_result=$this->query($J);}function
store_result($K=null){if(!$K){$K=$this->_result;if(!$K)return
false;}if($K->columnCount()){$K->num_rows=$K->rowCount();return$K;}$this->affected_rows=$K->rowCount();return
true;}function
next_result(){if(!$this->_result)return
false;$this->_result->_offset=0;return@$this->_result->nextRowset();}function
result($J,$k=0){$K=$this->query($J);if(!$K)return
false;$M=$K->fetch();return$M[$k];}}class
Min_PDOStatement
extends
PDOStatement{var$_offset=0,$num_rows;function
fetch_assoc(){return$this->fetch(PDO::FETCH_ASSOC);}function
fetch_row(){return$this->fetch(PDO::FETCH_NUM);}function
fetch_field(){$M=(object)$this->getColumnMeta($this->_offset++);$M->orgtable=$M->table;$M->orgname=$M->name;$M->charsetnr=(in_array("blob",(array)$M->flags)?63:0);return$M;}}}$mb=array();function
add_driver($s,$E){global$mb;$mb[$s]=$E;}function
get_driver($s){global$mb;return$mb[$s];}class
Min_SQL{var$_conn;function
__construct($f){$this->_conn=$f;}function
select($S,$O,$Z,$q,$G=array(),$z=1,$H=0,$Cd=false){global$b,$x;$w=(count($q)<count($O));$J=$b->selectQueryBuild($O,$Z,$q,$G,$z,$H);if(!$J)$J="SELECT".limit(($_GET["page"]!="last"&&$z!=""&&$q&&$w&&$x=="sql"?"SQL_CALC_FOUND_ROWS ":"").implode(", ",$O)."\nFROM ".table($S),($Z?"\nWHERE ".implode(" AND ",$Z):"").($q&&$w?"\nGROUP BY ".implode(", ",$q):"").($G?"\nORDER BY ".implode(", ",$G):""),($z!=""?+$z:null),($H?$z*$H:0),"\n");$ke=microtime(true);$L=$this->_conn->query($J);if($Cd)echo$b->selectQuery($J,$ke,!$L);return$L;}function
delete($S,$Id,$z=0){$J="FROM ".table($S);return
queries("DELETE".($z?limit1($S,$J,$Id):" $J$Id"));}function
update($S,$Q,$Id,$z=0,$be="\n"){$Ze=array();foreach($Q
as$y=>$W)$Ze[]="$y = $W";$J=table($S)." SET$be".implode(",$be",$Ze);return
queries("UPDATE".($z?limit1($S,$J,$Id,$be):" $J$Id"));}function
insert($S,$Q){return
queries("INSERT INTO ".table($S).($Q?" (".implode(", ",array_keys($Q)).")\nVALUES (".implode(", ",$Q).")":" DEFAULT VALUES"));}function
insertUpdate($S,$N,$Bd){return
false;}function
begin(){return
queries("BEGIN");}function
commit(){return
queries("COMMIT");}function
rollback(){return
queries("ROLLBACK");}function
slowQuery($J,$Be){}function
convertSearch($t,$W,$k){return$t;}function
value($W,$k){return(method_exists($this->_conn,'value')?$this->_conn->value($W,$k):(is_resource($W)?stream_get_contents($W):$W));}function
quoteBinary($Td){return
q($Td);}function
warnings(){return'';}function
tableHelp($E){}}$mb["mssql"]="MS SQL (beta)";define("DRIVER","mssql");if(extension_loaded("sqlsrv")){class
Min_DB{var$extension="sqlsrv",$_link,$_result,$server_info,$affected_rows,$errno,$error;function
_get_error(){$this->error="";foreach(sqlsrv_errors()as$j){$this->errno=$j["code"];$this->error.="$j[message]\n";}$this->error=rtrim($this->error);}function
connect($P,$U,$I){global$b;$h=$b->database();$Ta=array("UID"=>$U,"PWD"=>$I,"CharacterSet"=>"UTF-8");if($h!="")$Ta["Database"]=$h;$this->_link=@sqlsrv_connect(preg_replace('~:~',',',$P),$Ta);if($this->_link){$pc=sqlsrv_server_info($this->_link);$this->server_info=$pc['SQLServerVersion'];}else$this->_get_error();return(bool)$this->_link;}function
quote($R){return"'".str_replace("'","''",$R)."'";}function
select_db($cb){return$this->query("USE ".idf_escape($cb));}function
query($J,$Oe=false){$K=sqlsrv_query($this->_link,$J);$this->error="";if(!$K){$this->_get_error();return
false;}return$this->store_result($K);}function
multi_query($J){$this->_result=sqlsrv_query($this->_link,$J);$this->error="";if(!$this->_result){$this->_get_error();return
false;}return
true;}function
store_result($K=null){if(!$K)$K=$this->_result;if(!$K)return
false;if(sqlsrv_field_metadata($K))return
new
Min_Result($K);$this->affected_rows=sqlsrv_rows_affected($K);return
true;}function
next_result(){return$this->_result?sqlsrv_next_result($this->_result):null;}function
result($J,$k=0){$K=$this->query($J);if(!is_object($K))return
false;$M=$K->fetch_row();return$M[$k];}}class
Min_Result{var$_result,$_offset=0,$_fields,$num_rows;function
__construct($K){$this->_result=$K;}function
_convert($M){foreach((array)$M
as$y=>$W){if(is_a($W,'DateTime'))$M[$y]=$W->format("Y-m-d H:i:s");}return$M;}function
fetch_assoc(){return$this->_convert(sqlsrv_fetch_array($this->_result,SQLSRV_FETCH_ASSOC));}function
fetch_row(){return$this->_convert(sqlsrv_fetch_array($this->_result,SQLSRV_FETCH_NUMERIC));}function
fetch_field(){if(!$this->_fields)$this->_fields=sqlsrv_field_metadata($this->_result);$k=$this->_fields[$this->_offset++];$L=new
stdClass;$L->name=$k["Name"];$L->orgname=$k["Name"];$L->type=($k["Type"]==1?254:0);return$L;}function
seek($cd){for($r=0;$r<$cd;$r++)sqlsrv_fetch($this->_result);}function
__destruct(){sqlsrv_free_stmt($this->_result);}}}elseif(extension_loaded("mssql")){class
Min_DB{var$extension="MSSQL",$_link,$_result,$server_info,$affected_rows,$error;function
connect($P,$U,$I){$this->_link=@mssql_connect($P,$U,$I);if($this->_link){$K=$this->query("SELECT SERVERPROPERTY('ProductLevel'), SERVERPROPERTY('Edition')");if($K){$M=$K->fetch_row();$this->server_info=$this->result("sp_server_info 2",2)." [$M[0]] $M[1]";}}else$this->error=mssql_get_last_message();return(bool)$this->_link;}function
quote($R){return"'".str_replace("'","''",$R)."'";}function
select_db($cb){return
mssql_select_db($cb);}function
query($J,$Oe=false){$K=@mssql_query($J,$this->_link);$this->error="";if(!$K){$this->error=mssql_get_last_message();return
false;}if($K===true){$this->affected_rows=mssql_rows_affected($this->_link);return
true;}return
new
Min_Result($K);}function
multi_query($J){return$this->_result=$this->query($J);}function
store_result(){return$this->_result;}function
next_result(){return
mssql_next_result($this->_result->_result);}function
result($J,$k=0){$K=$this->query($J);if(!is_object($K))return
false;return
mssql_result($K->_result,0,$k);}}class
Min_Result{var$_result,$_offset=0,$_fields,$num_rows;function
__construct($K){$this->_result=$K;$this->num_rows=mssql_num_rows($K);}function
fetch_assoc(){return
mssql_fetch_assoc($this->_result);}function
fetch_row(){return
mssql_fetch_row($this->_result);}function
num_rows(){return
mssql_num_rows($this->_result);}function
fetch_field(){$L=mssql_fetch_field($this->_result);$L->orgtable=$L->table;$L->orgname=$L->name;return$L;}function
seek($cd){mssql_data_seek($this->_result,$cd);}function
__destruct(){mssql_free_result($this->_result);}}}elseif(extension_loaded("pdo_dblib")){class
Min_DB
extends
Min_PDO{var$extension="PDO_DBLIB";function
connect($P,$U,$I){$this->dsn("dblib:charset=utf8;host=".str_replace(":",";unix_socket=",preg_replace('~:(\d)~',';port=\1',$P)),$U,$I);return
true;}function
select_db($cb){return$this->query("USE ".idf_escape($cb));}}}class
Min_Driver
extends
Min_SQL{function
insertUpdate($S,$N,$Bd){foreach($N
as$Q){$T=array();$Z=array();foreach($Q
as$y=>$W){$T[]="$y = $W";if(isset($Bd[idf_unescape($y)]))$Z[]="$y = $W";}if(!queries("MERGE ".table($S)." USING (VALUES(".implode(", ",$Q).")) AS source (c".implode(", c",range(1,count($Q))).") ON ".implode(" AND ",$Z)." WHEN MATCHED THEN UPDATE SET ".implode(", ",$T)." WHEN NOT MATCHED THEN INSERT (".implode(", ",array_keys($Q)).") VALUES (".implode(", ",$Q).");"))return
false;}return
true;}function
begin(){return
queries("BEGIN TRANSACTION");}}function
idf_escape($t){return"[".str_replace("]","]]",$t)."]";}function
table($t){return($_GET["ns"]!=""?idf_escape($_GET["ns"]).".":"").idf_escape($t);}function
connect(){global$b;$f=new
Min_DB;$Xa=$b->credentials();if($f->connect($Xa[0],$Xa[1],$Xa[2]))return$f;return$f->error;}function
get_databases(){return
get_vals("SELECT name FROM sys.databases WHERE name NOT IN ('master', 'tempdb', 'model', 'msdb')");}function
limit($J,$Z,$z,$cd=0,$be=" "){return($z!==null?" TOP (".($z+$cd).")":"")." $J$Z";}function
limit1($S,$J,$Z,$be="\n"){return
limit($J,$Z,1,0,$be);}function
db_collation($h,$La){global$f;return$f->result("SELECT collation_name FROM sys.databases WHERE name = ".q($h));}function
engines(){return
array();}function
logged_user(){global$f;return$f->result("SELECT SUSER_NAME()");}function
tables_list(){return
get_key_vals("SELECT name, type_desc FROM sys.all_objects WHERE schema_id = SCHEMA_ID(".q(get_schema()).") AND type IN ('S', 'U', 'V') ORDER BY name");}function
count_tables($db){global$f;$L=array();foreach($db
as$h){$f->select_db($h);$L[$h]=$f->result("SELECT COUNT(*) FROM INFORMATION_SCHEMA.TABLES");}return$L;}function
table_status($E=""){$L=array();foreach(get_rows("SELECT ao.name AS Name, ao.type_desc AS Engine, (SELECT value FROM fn_listextendedproperty(default, 'SCHEMA', schema_name(schema_id), 'TABLE', ao.name, null, null)) AS Comment FROM sys.all_objects AS ao WHERE schema_id = SCHEMA_ID(".q(get_schema()).") AND type IN ('S', 'U', 'V') ".($E!=""?"AND name = ".q($E):"ORDER BY name"))as$M){if($E!="")return$M;$L[$M["Name"]]=$M;}return$L;}function
is_view($ue){return$ue["Engine"]=="VIEW";}function
fk_support($ue){return
true;}function
fields($S){$Pa=get_key_vals("SELECT objname, cast(value as varchar(max)) FROM fn_listextendedproperty('MS_DESCRIPTION', 'schema', ".q(get_schema()).", 'table', ".q($S).", 'column', NULL)");$L=array();foreach(get_rows("SELECT c.max_length, c.precision, c.scale, c.name, c.is_nullable, c.is_identity, c.collation_name, t.name type, CAST(d.definition as text) [default]
FROM sys.all_columns c
JOIN sys.all_objects o ON c.object_id = o.object_id
JOIN sys.types t ON c.user_type_id = t.user_type_id
LEFT JOIN sys.default_constraints d ON c.default_object_id = d.parent_column_id
WHERE o.schema_id = SCHEMA_ID(".q(get_schema()).") AND o.type IN ('S', 'U', 'V') AND o.name = ".q($S))as$M){$Me=$M["type"];$Fc=(preg_match("~char|binary~",$Me)?$M["max_length"]:($Me=="decimal"?"$M[precision],$M[scale]":""));$L[$M["name"]]=array("field"=>$M["name"],"full_type"=>$Me.($Fc?"($Fc)":""),"type"=>$Me,"length"=>$Fc,"default"=>$M["default"],"null"=>$M["is_nullable"],"auto_increment"=>$M["is_identity"],"collation"=>$M["collation_name"],"privileges"=>array("insert"=>1,"select"=>1,"update"=>1),"primary"=>$M["is_identity"],"comment"=>$Pa[$M["name"]],);}return$L;}function
indexes($S,$g=null){$L=array();foreach(get_rows("SELECT i.name, key_ordinal, is_unique, is_primary_key, c.name AS column_name, is_descending_key
FROM sys.indexes i
INNER JOIN sys.index_columns ic ON i.object_id = ic.object_id AND i.index_id = ic.index_id
INNER JOIN sys.columns c ON ic.object_id = c.object_id AND ic.column_id = c.column_id
WHERE OBJECT_NAME(i.object_id) = ".q($S),$g)as$M){$E=$M["name"];$L[$E]["type"]=($M["is_primary_key"]?"PRIMARY":($M["is_unique"]?"UNIQUE":"INDEX"));$L[$E]["lengths"]=array();$L[$E]["columns"][$M["key_ordinal"]]=$M["column_name"];$L[$E]["descs"][$M["key_ordinal"]]=($M["is_descending_key"]?'1':null);}return$L;}function
view($E){global$f;return
array("select"=>preg_replace('~^(?:[^[]|\[[^]]*])*\s+AS\s+~isU','',$f->result("SELECT VIEW_DEFINITION FROM INFORMATION_SCHEMA.VIEWS WHERE TABLE_SCHEMA = SCHEMA_NAME() AND TABLE_NAME = ".q($E))));}function
collations(){$L=array();foreach(get_vals("SELECT name FROM fn_helpcollations()")as$Ka)$L[preg_replace('~_.*~','',$Ka)][]=$Ka;return$L;}function
information_schema($h){return
false;}function
error(){global$f;return
nl_br(h(preg_replace('~^(\[[^]]*])+~m','',$f->error)));}function
create_database($h,$Ka){return
queries("CREATE DATABASE ".idf_escape($h).(preg_match('~^[a-z0-9_]+$~i',$Ka)?" COLLATE $Ka":""));}function
drop_databases($db){return
queries("DROP DATABASE ".implode(", ",array_map('idf_escape',$db)));}function
rename_database($E,$Ka){if(preg_match('~^[a-z0-9_]+$~i',$Ka))queries("ALTER DATABASE ".idf_escape(DB)." COLLATE $Ka");queries("ALTER DATABASE ".idf_escape(DB)." MODIFY NAME = ".idf_escape($E));return
true;}function
auto_increment(){return" IDENTITY".($_POST["Auto_increment"]!=""?"(".number($_POST["Auto_increment"]).",1)":"")." PRIMARY KEY";}function
alter_table($S,$E,$l,$Qb,$Oa,$xb,$Ka,$sa,$td){$ma=array();$Pa=array();foreach($l
as$k){$d=idf_escape($k[0]);$W=$k[1];if(!$W)$ma["DROP"][]=" COLUMN $d";else{$W[1]=preg_replace("~( COLLATE )'(\\w+)'~",'\1\2',$W[1]);$Pa[$k[0]]=$W[5];unset($W[5]);if($k[0]=="")$ma["ADD"][]="\n  ".implode("",$W).($S==""?substr($Qb[$W[0]],16+strlen($W[0])):"");else{unset($W[6]);if($d!=$W[0])queries("EXEC sp_rename ".q(table($S).".$d").", ".q(idf_unescape($W[0])).", 'COLUMN'");$ma["ALTER COLUMN ".implode("",$W)][]="";}}}if($S=="")return
queries("CREATE TABLE ".table($E)." (".implode(",",(array)$ma["ADD"])."\n)");if($S!=$E)queries("EXEC sp_rename ".q(table($S)).", ".q($E));if($Qb)$ma[""]=$Qb;foreach($ma
as$y=>$W){if(!queries("ALTER TABLE ".idf_escape($E)." $y".implode(",",$W)))return
false;}foreach($Pa
as$y=>$W){$Oa=substr($W,9);queries("EXEC sp_dropextendedproperty @name = N'MS_Description', @level0type = N'Schema', @level0name = ".q(get_schema()).", @level1type = N'Table', @level1name = ".q($E).", @level2type = N'Column', @level2name = ".q($y));queries("EXEC sp_addextendedproperty @name = N'MS_Description', @value = ".$Oa.", @level0type = N'Schema', @level0name = ".q(get_schema()).", @level1type = N'Table', @level1name = ".q($E).", @level2type = N'Column', @level2name = ".q($y));}return
true;}function
alter_indexes($S,$ma){$u=array();$nb=array();foreach($ma
as$W){if($W[2]=="DROP"){if($W[0]=="PRIMARY")$nb[]=idf_escape($W[1]);else$u[]=idf_escape($W[1])." ON ".table($S);}elseif(!queries(($W[0]!="PRIMARY"?"CREATE $W[0] ".($W[0]!="INDEX"?"INDEX ":"").idf_escape($W[1]!=""?$W[1]:uniqid($S."_"))." ON ".table($S):"ALTER TABLE ".table($S)." ADD PRIMARY KEY")." (".implode(", ",$W[2]).")"))return
false;}return(!$u||queries("DROP INDEX ".implode(", ",$u)))&&(!$nb||queries("ALTER TABLE ".table($S)." DROP ".implode(", ",$nb)));}function
last_id(){global$f;return$f->result("SELECT SCOPE_IDENTITY()");}function
explain($f,$J){$f->query("SET SHOWPLAN_ALL ON");$L=$f->query($J);$f->query("SET SHOWPLAN_ALL OFF");return$L;}function
found_rows($ue,$Z){}function
foreign_keys($S){$L=array();foreach(get_rows("EXEC sp_fkeys @fktable_name = ".q($S))as$M){$n=&$L[$M["FK_NAME"]];$n["db"]=$M["PKTABLE_QUALIFIER"];$n["table"]=$M["PKTABLE_NAME"];$n["source"][]=$M["FKCOLUMN_NAME"];$n["target"][]=$M["PKCOLUMN_NAME"];}return$L;}function
truncate_tables($ve){return
apply_queries("TRUNCATE TABLE",$ve);}function
drop_views($bf){return
queries("DROP VIEW ".implode(", ",array_map('table',$bf)));}function
drop_tables($ve){return
queries("DROP TABLE ".implode(", ",array_map('table',$ve)));}function
move_tables($ve,$bf,$xe){return
apply_queries("ALTER SCHEMA ".idf_escape($xe)." TRANSFER",array_merge($ve,$bf));}function
trigger($E){if($E=="")return
array();$N=get_rows("SELECT s.name [Trigger],
CASE WHEN OBJECTPROPERTY(s.id, 'ExecIsInsertTrigger') = 1 THEN 'INSERT' WHEN OBJECTPROPERTY(s.id, 'ExecIsUpdateTrigger') = 1 THEN 'UPDATE' WHEN OBJECTPROPERTY(s.id, 'ExecIsDeleteTrigger') = 1 THEN 'DELETE' END [Event],
CASE WHEN OBJECTPROPERTY(s.id, 'ExecIsInsteadOfTrigger') = 1 THEN 'INSTEAD OF' ELSE 'AFTER' END [Timing],
c.text
FROM sysobjects s
JOIN syscomments c ON s.id = c.id
WHERE s.xtype = 'TR' AND s.name = ".q($E));$L=reset($N);if($L)$L["Statement"]=preg_replace('~^.+\s+AS\s+~isU','',$L["text"]);return$L;}function
triggers($S){$L=array();foreach(get_rows("SELECT sys1.name,
CASE WHEN OBJECTPROPERTY(sys1.id, 'ExecIsInsertTrigger') = 1 THEN 'INSERT' WHEN OBJECTPROPERTY(sys1.id, 'ExecIsUpdateTrigger') = 1 THEN 'UPDATE' WHEN OBJECTPROPERTY(sys1.id, 'ExecIsDeleteTrigger') = 1 THEN 'DELETE' END [Event],
CASE WHEN OBJECTPROPERTY(sys1.id, 'ExecIsInsteadOfTrigger') = 1 THEN 'INSTEAD OF' ELSE 'AFTER' END [Timing]
FROM sysobjects sys1
JOIN sysobjects sys2 ON sys1.parent_obj = sys2.id
WHERE sys1.xtype = 'TR' AND sys2.name = ".q($S))as$M)$L[$M["name"]]=array($M["Timing"],$M["Event"]);return$L;}function
trigger_options(){return
array("Timing"=>array("AFTER","INSTEAD OF"),"Event"=>array("INSERT","UPDATE","DELETE"),"Type"=>array("AS"),);}function
schemas(){return
get_vals("SELECT name FROM sys.schemas");}function
get_schema(){global$f;if($_GET["ns"]!="")return$_GET["ns"];return$f->result("SELECT SCHEMA_NAME()");}function
set_schema($Ud){return
true;}function
use_sql($cb){return"USE ".idf_escape($cb);}function
show_variables(){return
array();}function
show_status(){return
array();}function
convert_field($k){}function
unconvert_field($k,$L){return$L;}function
support($Jb){return
preg_match('~^(comment|columns|database|drop_col|indexes|descidx|scheme|sql|table|trigger|view|view_trigger)$~',$Jb);}function
driver_config(){$Ne=array();$me=array();foreach(array('数字'=>array("tinyint"=>3,"smallint"=>5,"int"=>10,"bigint"=>20,"bit"=>1,"decimal"=>0,"real"=>12,"float"=>53,"smallmoney"=>10,"money"=>20),'日期时间'=>array("date"=>10,"smalldatetime"=>19,"datetime"=>19,"datetime2"=>19,"time"=>8,"datetimeoffset"=>10),'字符串'=>array("char"=>8000,"varchar"=>8000,"text"=>2147483647,"nchar"=>4000,"nvarchar"=>4000,"ntext"=>1073741823),'二进制'=>array("binary"=>8000,"varbinary"=>8000,"image"=>2147483647),)as$y=>$W){$Ne+=$W;$me[$y]=array_keys($W);}return
array('possible_drivers'=>array("SQLSRV","MSSQL","PDO_DBLIB"),'jush'=>"mssql",'types'=>$Ne,'structured_types'=>$me,'unsigned'=>array(),'operators'=>array("=","<",">","<=",">=","!=","LIKE","LIKE %%","IN","IS NULL","NOT LIKE","NOT IN","IS NOT NULL"),'functions'=>array("distinct","len","lower","round","upper"),'grouping'=>array("avg","count","count distinct","max","min","sum"),'edit_functions'=>array(array("date|time"=>"getdate",),array("int|decimal|real|float|money|datetime"=>"+/-","char|text"=>"+",)),);}class
Adminer{var$operators=array("<=",">=");var$_values=array();function
name(){return"<a href='https://www.adminer.org/editor/'".target_blank()." id='h1'>".'编辑器'."</a>";}function
credentials(){return
array(SERVER,$_GET["username"],get_password());}function
connectSsl(){}function
permanentLogin($Wa=false){return
password_file($Wa);}function
bruteForceKey(){return$_SERVER["REMOTE_ADDR"];}function
serverName($P){}function
database(){global$f;if($f){$db=$this->databases(false);return(!$db?$f->result("SELECT SUBSTRING_INDEX(CURRENT_USER, '@', 1)"):$db[(information_schema($db[0])?1:0)]);}}function
schemas(){return
schemas();}function
databases($Ob=true){return
get_databases($Ob);}function
queryTimeout(){return
5;}function
headers(){}function
csp(){return
csp();}function
head(){return
true;}function
css(){$L=array();$m="adminer.css";if(file_exists($m))$L[]=$m;return$L;}function
loginForm(){echo"<table cellspacing='0' class='layout'>\n",$this->loginFormField('username','<tr><th>'.'用户名'.'<td>','<input type="hidden" name="auth[driver]" value="server"><input name="auth[username]" id="username" value="'.h($_GET["username"]).'" autocomplete="username" autocapitalize="off">'.script("focus(qs('#username'));")),$this->loginFormField('password','<tr><th>'.'密码'.'<td>','<input type="password" name="auth[password]" autocomplete="current-password">'."\n"),"</table>\n","<p><input type='submit' value='".'登录'."'>\n",checkbox("auth[permanent]",1,$_COOKIE["adminer_permanent"],'保持登录')."\n";}function
loginFormField($E,$hc,$X){return$hc.$X;}function
login($Kc,$I){return
true;}function
tableName($se){return
h($se["Comment"]!=""?$se["Comment"]:$se["Name"]);}function
fieldName($k,$G=0){return
h(preg_replace('~\s+\[.*\]$~','',($k["comment"]!=""?$k["comment"]:$k["field"])));}function
selectLinks($se,$Q=""){$a=$se["Name"];if($Q!==null)echo'<p class="tabs"><a href="'.h(ME.'edit='.urlencode($a).$Q).'">'.'新建数据'."</a>\n";}function
foreignKeys($S){return
foreign_keys($S);}function
backwardKeys($S,$re){$L=array();foreach(get_rows("SELECT TABLE_NAME, CONSTRAINT_NAME, COLUMN_NAME, REFERENCED_COLUMN_NAME
FROM information_schema.KEY_COLUMN_USAGE
WHERE TABLE_SCHEMA = ".q($this->database())."
AND REFERENCED_TABLE_SCHEMA = ".q($this->database())."
AND REFERENCED_TABLE_NAME = ".q($S)."
ORDER BY ORDINAL_POSITION",null,"")as$M)$L[$M["TABLE_NAME"]]["keys"][$M["CONSTRAINT_NAME"]][$M["COLUMN_NAME"]]=$M["REFERENCED_COLUMN_NAME"];foreach($L
as$y=>$W){$E=$this->tableName(table_status($y,true));if($E!=""){$Vd=preg_quote($re);$be="(:|\\s*-)?\\s+";$L[$y]["name"]=(preg_match("(^$Vd$be(.+)|^(.+?)$be$Vd\$)iu",$E,$B)?$B[2].$B[3]:$E);}else
unset($L[$y]);}return$L;}function
backwardKeysPrint($va,$M){foreach($va
as$S=>$ua){foreach($ua["keys"]as$Ma){$_=ME.'select='.urlencode($S);$r=0;foreach($Ma
as$d=>$W)$_.=where_link($r++,$d,$M[$W]);echo"<a href='".h($_)."'>".h($ua["name"])."</a>";$_=ME.'edit='.urlencode($S);foreach($Ma
as$d=>$W)$_.="&set".urlencode("[".bracket_escape($d)."]")."=".urlencode($M[$W]);echo"<a href='".h($_)."' title='".'新建数据'."'>+</a> ";}}}function
selectQuery($J,$ke,$Hb=false){return"<!--\n".str_replace("--","--><!-- ",$J)."\n(".format_time($ke).")\n-->\n";}function
rowDescription($S){foreach(fields($S)as$k){if(preg_match("~varchar|character varying~",$k["type"]))return
idf_escape($k["field"]);}return"";}function
rowDescriptions($N,$Sb){$L=$N;foreach($N[0]as$y=>$W){if(list($S,$s,$E)=$this->_foreignColumn($Sb,$y)){$mc=array();foreach($N
as$M)$mc[$M[$y]]=q($M[$y]);$hb=$this->_values[$S];if(!$hb)$hb=get_key_vals("SELECT $s, $E FROM ".table($S)." WHERE $s IN (".implode(", ",$mc).")");foreach($N
as$D=>$M){if(isset($M[$y]))$L[$D][$y]=(string)$hb[$M[$y]];}}}return$L;}function
selectLink($W,$k){}function
selectVal($W,$_,$k,$nd){$L=$W;$_=h($_);if(preg_match('~blob|bytea~',$k["type"])&&!is_utf8($W)){$L=sprintf('%d 字节',strlen($nd));if(preg_match("~^(GIF|\xFF\xD8\xFF|\x89PNG\x0D\x0A\x1A\x0A)~",$nd))$L="<img src='$_' alt='$L'>";}if(like_bool($k)&&$L!="")$L=(preg_match('~^(1|t|true|y|yes|on)$~i',$W)?'是':'否');if($_)$L="<a href='$_'".(is_url($_)?target_blank():"").">$L</a>";if(!$_&&!like_bool($k)&&preg_match(number_type(),$k["type"]))$L="<div class='number'>$L</div>";elseif(preg_match('~date~',$k["type"]))$L="<div class='datetime'>$L</div>";return$L;}function
editVal($W,$k){if(preg_match('~date|timestamp~',$k["type"])&&$W!==null)return
preg_replace('~^(\d{2}(\d+))-(0?(\d+))-(0?(\d+))~','$1.$3.$5',$W);return$W;}function
selectColumnsPrint($O,$e){}function
selectSearchPrint($Z,$e,$v){$Z=(array)$_GET["where"];echo'<fieldset id="fieldset-search"><legend>'.'搜索'."</legend><div>\n";$yc=array();foreach($Z
as$y=>$W)$yc[$W["col"]]=$y;$r=0;$l=fields($_GET["select"]);foreach($e
as$E=>$gb){$k=$l[$E];if(preg_match("~enum~",$k["type"])||like_bool($k)){$y=$yc[$E];$r--;echo"<div>".h($gb)."<input type='hidden' name='where[$r][col]' value='".h($E)."'>:",(like_bool($k)?" <select name='where[$r][val]'>".optionlist(array(""=>"",'否','是'),$Z[$y]["val"],true)."</select>":enum_input("checkbox"," name='where[$r][val][]'",$k,(array)$Z[$y]["val"],($k["null"]?0:null))),"</div>\n";unset($e[$E]);}elseif(is_array($F=$this->_foreignKeyOptions($_GET["select"],$E))){if($l[$E]["null"])$F[0]='('.'空'.')';$y=$yc[$E];$r--;echo"<div>".h($gb)."<input type='hidden' name='where[$r][col]' value='".h($E)."'><input type='hidden' name='where[$r][op]' value='='>: <select name='where[$r][val]'>".optionlist($F,$Z[$y]["val"],true)."</select></div>\n";unset($e[$E]);}}$r=0;foreach($Z
as$W){if(($W["col"]==""||$e[$W["col"]])&&"$W[col]$W[val]"!=""){echo"<div><select name='where[$r][col]'><option value=''>(".'任意位置'.")".optionlist($e,$W["col"],true)."</select>",html_select("where[$r][op]",array(-1=>"")+$this->operators,$W["op"]),"<input type='search' name='where[$r][val]' value='".h($W["val"])."'>".script("mixin(qsl('input'), {onkeydown: selectSearchKeydown, onsearch: selectSearchSearch});","")."</div>\n";$r++;}}echo"<div><select name='where[$r][col]'><option value=''>(".'任意位置'.")".optionlist($e,null,true)."</select>",script("qsl('select').onchange = selectAddRow;",""),html_select("where[$r][op]",array(-1=>"")+$this->operators),"<input type='search' name='where[$r][val]'></div>",script("mixin(qsl('input'), {onchange: function () { this.parentNode.firstChild.onchange(); }, onsearch: selectSearchSearch});"),"</div></fieldset>\n";}function
selectOrderPrint($G,$e,$v){$md=array();foreach($v
as$y=>$u){$G=array();foreach($u["columns"]as$W)$G[]=$e[$W];if(count(array_filter($G,'strlen'))>1&&$y!="PRIMARY")$md[$y]=implode(", ",$G);}if($md){echo'<fieldset><legend>'.'排序'."</legend><div>","<select name='index_order'>".optionlist(array(""=>"")+$md,($_GET["order"][0]!=""?"":$_GET["index_order"]),true)."</select>","</div></fieldset>\n";}if($_GET["order"])echo"<div style='display: none;'>".hidden_fields(array("order"=>array(1=>reset($_GET["order"])),"desc"=>($_GET["desc"]?array(1=>1):array()),))."</div>\n";}function
selectLimitPrint($z){echo"<fieldset><legend>".'范围'."</legend><div>";echo
html_select("limit",array("","50","100"),$z),"</div></fieldset>\n";}function
selectLengthPrint($ze){}function
selectActionPrint($v){echo"<fieldset><legend>".'动作'."</legend><div>","<input type='submit' value='".'选择'."'>","</div></fieldset>\n";}function
selectCommandPrint(){return
true;}function
selectImportPrint(){return
true;}function
selectEmailPrint($ub,$e){if($ub){print_fieldset("email",'电子邮件',$_POST["email_append"]);echo"<div>",script("qsl('div').onkeydown = partialArg(bodyKeydown, 'email');"),"<p>".'来自'.": <input name='email_from' value='".h($_POST?$_POST["email_from"]:$_COOKIE["adminer_email"])."'>\n",'主题'.": <input name='email_subject' value='".h($_POST["email_subject"])."'>\n","<p><textarea name='email_message' rows='15' cols='75'>".h($_POST["email_message"].($_POST["email_append"]?'{$'."$_POST[email_addition]}":""))."</textarea>\n","<p>".script("qsl('p').onkeydown = partialArg(bodyKeydown, 'email_append');","").html_select("email_addition",$e,$_POST["email_addition"])."<input type='submit' name='email_append' value='".'插入'."'>\n";echo"<p>".'附件'.": <input type='file' name='email_files[]'>".script("qsl('input').onchange = emailFileChange;"),"<p>".(count($ub)==1?'<input type="hidden" name="email_field" value="'.h(key($ub)).'">':html_select("email_field",$ub)),"<input type='submit' name='email' value='".'发送'."'>".confirm(),"</div>\n","</div></fieldset>\n";}}function
selectColumnsProcess($e,$v){return
array(array(),array());}function
selectSearchProcess($l,$v){global$i;$L=array();foreach((array)$_GET["where"]as$y=>$Z){$Ja=$Z["col"];$hd=$Z["op"];$W=$Z["val"];if(($y<0?"":$Ja).$W!=""){$Qa=array();foreach(($Ja!=""?array($Ja=>$l[$Ja]):$l)as$E=>$k){if($Ja!=""||is_numeric($W)||!preg_match(number_type(),$k["type"])){$E=idf_escape($E);if($Ja!=""&&$k["type"]=="enum")$Qa[]=(in_array(0,$W)?"$E IS NULL OR ":"")."$E IN (".implode(", ",array_map('intval',$W)).")";else{$_e=preg_match('~char|text|enum|set~',$k["type"]);$X=$this->processInput($k,(!$hd&&$_e&&preg_match('~^[^%]+$~',$W)?"%$W%":$W));$Qa[]=$i->convertSearch($E,$W,$k).($X=="NULL"?" IS".($hd==">="?" NOT":"")." $X":(in_array($hd,$this->operators)||$hd=="="?" $hd $X":($_e?" LIKE $X":" IN (".str_replace(",","', '",$X).")")));if($y<0&&$W=="0")$Qa[]="$E IS NULL";}}}$L[]=($Qa?"(".implode(" OR ",$Qa).")":"1 = 0");}}return$L;}function
selectOrderProcess($l,$v){$oc=$_GET["index_order"];if($oc!="")unset($_GET["order"][1]);if($_GET["order"])return
array(idf_escape(reset($_GET["order"])).($_GET["desc"]?" DESC":""));foreach(($oc!=""?array($v[$oc]):$v)as$u){if($oc!=""||$u["type"]=="INDEX"){$cc=array_filter($u["descs"]);$gb=false;foreach($u["columns"]as$W){if(preg_match('~date|timestamp~',$l[$W]["type"])){$gb=true;break;}}$L=array();foreach($u["columns"]as$y=>$W)$L[]=idf_escape($W).(($cc?$u["descs"][$y]:$gb)?" DESC":"");return$L;}}return
array();}function
selectLimitProcess(){return(isset($_GET["limit"])?$_GET["limit"]:"50");}function
selectLengthProcess(){return"100";}function
selectEmailProcess($Z,$Sb){if($_POST["email_append"])return
true;if($_POST["email"]){$Zd=0;if($_POST["all"]||$_POST["check"]){$k=idf_escape($_POST["email_field"]);$oe=$_POST["email_subject"];$C=$_POST["email_message"];preg_match_all('~\{\$([a-z0-9_]+)\}~i',"$oe.$C",$Nc);$N=get_rows("SELECT DISTINCT $k".($Nc[1]?", ".implode(", ",array_map('idf_escape',array_unique($Nc[1]))):"")." FROM ".table($_GET["select"])." WHERE $k IS NOT NULL AND $k != ''".($Z?" AND ".implode(" AND ",$Z):"").($_POST["all"]?"":" AND ((".implode(") OR (",array_map('where_check',(array)$_POST["check"]))."))"));$l=fields($_GET["select"]);foreach($this->rowDescriptions($N,$Sb)as$M){$Od=array('{\\'=>'{');foreach($Nc[1]as$W)$Od['{$'."$W}"]=$this->editVal($M[$W],$l[$W]);$tb=$M[$_POST["email_field"]];if(is_mail($tb)&&send_mail($tb,strtr($oe,$Od),strtr($C,$Od),$_POST["email_from"],$_FILES["email_files"]))$Zd++;}}cookie("adminer_email",$_POST["email_from"]);redirect(remove_from_uri(),sprintf('%d 封邮件已发送。',$Zd));}return
false;}function
selectQueryBuild($O,$Z,$q,$G,$z,$H){return"";}function
messageQuery($J,$Ae,$Hb=false){return" <span class='time'>".@date("H:i:s")."</span><!--\n".str_replace("--","--><!-- ",$J)."\n".($Ae?"($Ae)\n":"")."-->";}function
editRowPrint($S,$l,$M,$T){}function
editFunctions($k){$L=array();if($k["null"]&&preg_match('~blob~',$k["type"]))$L["NULL"]='空';$L[""]=($k["null"]||$k["auto_increment"]||like_bool($k)?"":"*");if(preg_match('~date|time~',$k["type"]))$L["now"]='现在';if(preg_match('~_(md5|sha1)$~i',$k["field"],$B))$L[]=strtolower($B[1]);return$L;}function
editInput($S,$k,$c,$X){if($k["type"]=="enum")return(isset($_GET["select"])?"<label><input type='radio'$c value='-1' checked><i>".'原始'."</i></label> ":"").enum_input("radio",$c,$k,($X||isset($_GET["select"])?$X:0),($k["null"]?"":null));$F=$this->_foreignKeyOptions($S,$k["field"],$X);if($F!==null)return(is_array($F)?"<select$c>".optionlist($F,$X,true)."</select>":"<input value='".h($X)."'$c class='hidden'>"."<input value='".h($F)."' class='jsonly'>"."<div></div>".script("qsl('input').oninput = partial(whisper, '".ME."script=complete&source=".urlencode($S)."&field=".urlencode($k["field"])."&value=');
qsl('div').onclick = whisperClick;",""));if(like_bool($k))return'<input type="checkbox" value="1"'.(preg_match('~^(1|t|true|y|yes|on)$~i',$X)?' checked':'')."$c>";$ic="";if(preg_match('~time~',$k["type"]))$ic='HH:MM:SS';if(preg_match('~date|timestamp~',$k["type"]))$ic='[yyyy].mm.dd'.($ic?" [$ic]":"");if($ic)return"<input value='".h($X)."'$c> ($ic)";if(preg_match('~_(md5|sha1)$~i',$k["field"]))return"<input type='password' value='".h($X)."'$c>";return'';}function
editHint($S,$k,$X){return(preg_match('~\s+(\[.*\])$~',($k["comment"]!=""?$k["comment"]:$k["field"]),$B)?h(" $B[1]"):'');}function
processInput($k,$X,$p=""){if($p=="now")return"$p()";$L=$X;if(preg_match('~date|timestamp~',$k["type"])&&preg_match('(^'.str_replace('\$1','(?P<p1>\d*)',preg_replace('~(\\\\\\$([2-6]))~','(?P<p\2>\d{1,2})',preg_quote('$1.$3.$5'))).'(.*))',$X,$B))$L=($B["p1"]!=""?$B["p1"]:($B["p2"]!=""?($B["p2"]<70?20:19).$B["p2"]:gmdate("Y")))."-$B[p3]$B[p4]-$B[p5]$B[p6]".end($B);$L=($k["type"]=="bit"&&preg_match('~^[0-9]+$~',$X)?$L:q($L));if($X==""&&like_bool($k))$L="'0'";elseif($X==""&&($k["null"]||!preg_match('~char|text~',$k["type"])))$L="NULL";elseif(preg_match('~^(md5|sha1)$~',$p))$L="$p($L)";return
unconvert_field($k,$L);}function
dumpOutput(){return
array();}function
dumpFormat(){return
array('csv'=>'CSV,','csv;'=>'CSV;','tsv'=>'TSV');}function
dumpDatabase($h){}function
dumpTable($S,$ne,$wc=0){echo"\xef\xbb\xbf";}function
dumpData($S,$ne,$J){global$f;$K=$f->query($J,1);if($K){while($M=$K->fetch_assoc()){if($ne=="table"){dump_csv(array_keys($M));$ne="INSERT";}dump_csv($M);}}}function
dumpFilename($lc){return
friendly_url($lc);}function
dumpHeaders($lc,$Vc=false){$Fb="csv";header("Content-Type: text/csv; charset=utf-8");return$Fb;}function
importServerPath(){}function
homepage(){return
true;}function
navigation($Uc){global$ca;echo'<h1>
',$this->name(),' <span class="version">',$ca,'</span>
<a href="https://www.adminer.org/editor/#download"',target_blank(),' id="version">',(version_compare($ca,$_COOKIE["adminer_version"])<0?h($_COOKIE["adminer_version"]):""),'</a>
</h1>
';if($Uc=="auth"){$Nb=true;foreach((array)$_SESSION["pwds"]as$Y=>$de){foreach($de[""]as$U=>$I){if($I!==null){if($Nb){echo"<ul id='logins'>",script("mixin(qs('#logins'), {onmouseover: menuOver, onmouseout: menuOut});");$Nb=false;}echo"<li><a href='".h(auth_url($Y,"",$U))."'>".($U!=""?h($U):"<i>".'空'."</i>")."</a>\n";}}}}else{$this->databasesPrint($Uc);if($Uc!="db"&&$Uc!="ns"){$ue=table_status('',true);if(!$ue)echo"<p class='message'>".'没有表。'."\n";else$this->tablesPrint($ue);}}}function
databasesPrint($Uc){}function
tablesPrint($ve){echo"<ul id='tables'>",script("mixin(qs('#tables'), {onmouseover: menuOver, onmouseout: menuOut});");foreach($ve
as$M){echo'<li>';$E=$this->tableName($M);if(isset($M["Engine"])&&$E!="")echo"<a href='".h(ME).'select='.urlencode($M["Name"])."'".bold($_GET["select"]==$M["Name"]||$_GET["edit"]==$M["Name"],"select")." title='".'选择数据'."'>$E</a>\n";}echo"</ul>\n";}function
_foreignColumn($Sb,$d){foreach((array)$Sb[$d]as$Rb){if(count($Rb["source"])==1){$E=$this->rowDescription($Rb["table"]);if($E!=""){$s=idf_escape($Rb["target"][0]);return
array($Rb["table"],$s,$E);}}}}function
_foreignKeyOptions($S,$d,$X=null){global$f;if(list($xe,$s,$E)=$this->_foreignColumn(column_foreign_keys($S),$d)){$L=&$this->_values[$xe];if($L===null){$ue=table_status($xe);$L=($ue["Rows"]>1000?"":array(""=>"")+get_key_vals("SELECT $s, $E FROM ".table($xe)." ORDER BY 2"));}if(!$L&&$X!==null)return$f->result("SELECT $E FROM ".table($xe)." WHERE $s = ".q($X));return$L;}}}$b=(function_exists('adminer_object')?adminer_object():new
Adminer);$Ra=driver_config();$_d=$Ra['possible_drivers'];$x=$Ra['jush'];$Ne=$Ra['types'];$me=$Ra['structured_types'];$Ue=$Ra['unsigned'];$kd=$Ra['operators'];$jd=isset($Ra['operator_regexp'])&&in_array($Ra['operator_regexp'],$kd)?$Ra['operator_regexp']:null;$Xb=$Ra['functions'];$ac=$Ra['grouping'];$qb=$Ra['edit_functions'];if($b->operators===null){$b->operators=$kd;$b->operator_regexp=$jd;}define("SERVER",$_GET[DRIVER]);define("DB",$_GET["db"]);define("ME",preg_replace('~\?.*~','',relative_uri()).'?'.(sid()?SID.'&':'').(SERVER!==null?DRIVER."=".urlencode(SERVER).'&':'').(isset($_GET["username"])?"username=".urlencode($_GET["username"]).'&':'').(DB!=""?'db='.urlencode(DB).'&'.(isset($_GET["ns"])?"ns=".urlencode($_GET["ns"])."&":""):''));$ca="4.8.3";function
page_header($Ce,$j="",$Ba=array(),$De=""){global$ba,$ca,$b,$mb,$x;page_headers();if(is_ajax()&&$j){page_messages($j);exit;}$Ee=$Ce.($De!=""?": $De":"");$Fe=strip_tags($Ee.(SERVER!=""&&SERVER!="localhost"?h(" - ".SERVER):"")." - ".$b->name());echo'<!DOCTYPE html>
<html lang="zh" dir="ltr">
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta name="robots" content="noindex">
<title>',$Fe,'</title>
<link rel="stylesheet" type="text/css" href="',h(preg_replace("~\\?.*~","",ME)."?file=default.css&version=4.8.3"),'">
',script_src(preg_replace("~\\?.*~","",ME)."?file=functions.js&version=4.8.3");if($b->head()){echo'<link rel="shortcut icon" type="image/x-icon" href="',h(preg_replace("~\\?.*~","",ME)."?file=favicon.ico&version=4.8.3"),'">
<link rel="apple-touch-icon" href="',h(preg_replace("~\\?.*~","",ME)."?file=favicon.ico&version=4.8.3"),'">
';foreach($b->css()as$Za){echo'<link rel="stylesheet" type="text/css" href="',h($Za),'">
';}}echo'
<body class="ltr nojs">
';$m=get_temp_dir()."/adminer.version";if(!$_COOKIE["adminer_version"]&&function_exists('openssl_verify')&&file_exists($m)&&filemtime($m)+86400>time()){$af=unserialize(file_get_contents($m));$Fd="-----BEGIN PUBLIC KEY-----
MIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEAwqWOVuF5uw7/+Z70djoK
RlHIZFZPO0uYRezq90+7Amk+FDNd7KkL5eDve+vHRJBLAszF/7XKXe11xwliIsFs
DFWQlsABVZB3oisKCBEuI71J4kPH8dKGEWR9jDHFw3cWmoH3PmqImX6FISWbG3B8
h7FIx3jEaw5ckVPVTeo5JRm/1DZzJxjyDenXvBQ/6o9DgZKeNDgxwKzH+sw9/YCO
jHnq1cFpOIISzARlrHMa/43YfeNRAm/tsBXjSxembBPo7aQZLAWHmaj5+K19H10B
nCpz9Y++cipkVEiKRGih4ZEvjoFysEOdRLj6WiD/uUNky4xGeA6LaJqh5XpkFkcQ
fQIDAQAB
-----END PUBLIC KEY-----
";if(openssl_verify($af["version"],base64_decode($af["signature"]),$Fd)==1)$_COOKIE["adminer_version"]=$af["version"];}echo'<script',nonce(),'>
mixin(document.body, {onkeydown: bodyKeydown, onclick: bodyClick',(isset($_COOKIE["adminer_version"])?"":", onload: partial(verifyVersion, '$ca', '".js_escape(ME)."', '".get_token()."')");?>});
document.body.className = document.body.className.replace(/ nojs/, ' js');
var offlineMessage = '<?php echo
js_escape('您离线了。'),'\';
var thousandsSeparator = \'',js_escape(','),'\';
</script>

<div id="help" class="jush-',$x,' jsonly hidden"></div>
',script("mixin(qs('#help'), {onmouseover: function () { helpOpen = 1; }, onmouseout: helpMouseout});"),'
<div id="content">
';if($Ba!==null){$_=substr(preg_replace('~\b(username|db|ns)=[^&]*&~','',ME),0,-1);echo'<p id="breadcrumb"><a href="'.h($_?$_:".").'">'.$mb[DRIVER].'</a> &raquo; ';$_=substr(preg_replace('~\b(db|ns)=[^&]*&~','',ME),0,-1);$P=$b->serverName(SERVER);$P=($P!=""?$P:'服务器');if($Ba===false)echo"$P\n";else{echo"<a href='".h($_)."' accesskey='1' title='Alt+Shift+1'>$P</a> &raquo; ";if($_GET["ns"]!=""||(DB!=""&&is_array($Ba)))echo'<a href="'.h($_."&db=".urlencode(DB).(support("scheme")?"&ns=":"")).'">'.h(DB).'</a> &raquo; ';if(is_array($Ba)){if($_GET["ns"]!="")echo'<a href="'.h(substr(ME,0,-1)).'">'.h($_GET["ns"]).'</a> &raquo; ';foreach($Ba
as$y=>$W){$gb=(is_array($W)?$W[1]:h($W));if($gb!="")echo"<a href='".h(ME."$y=").urlencode(is_array($W)?$W[0]:$W)."'>$gb</a> &raquo; ";}}echo"$Ce\n";}}echo"<h2>$Ee</h2>\n","<div id='ajaxstatus' class='jsonly hidden'></div>\n";restart_session();page_messages($j);$db=&get_session("dbs");if(DB!=""&&$db&&!in_array(DB,$db,true))$db=null;stop_session();define("PAGE_HEADER",1);}function
page_headers(){global$b;header("Content-Type: text/html; charset=utf-8");header("Cache-Control: no-cache");header("X-Frame-Options: deny");header("X-XSS-Protection: 0");header("X-Content-Type-Options: nosniff");header("Referrer-Policy: origin-when-cross-origin");foreach($b->csp()as$Ya){$fc=array();foreach($Ya
as$y=>$W)$fc[]="$y $W";header("Content-Security-Policy: ".implode("; ",$fc));}$b->headers();}function
csp(){return
array(array("script-src"=>"'self' 'unsafe-inline' 'nonce-".get_nonce()."' 'strict-dynamic'","connect-src"=>"'self'","frame-src"=>"https://www.adminer.org","object-src"=>"'none'","base-uri"=>"'none'","form-action"=>"'self'",),);}function
get_nonce(){static$Zc;if(!$Zc)$Zc=base64_encode(rand_string());return$Zc;}function
page_messages($j){$Ve=preg_replace('~^[^?]*~','',$_SERVER["REQUEST_URI"]);$Tc=$_SESSION["messages"][$Ve];if($Tc){echo"<div class='message'>".implode("</div>\n<div class='message'>",$Tc)."</div>".script("messagesPrint();");unset($_SESSION["messages"][$Ve]);}if($j)echo"<div class='error'>$j</div>\n";}function
page_footer($Uc=""){global$b,$He;echo'</div>

';if($Uc!="auth"){echo'<form action="" method="post">
<p class="logout">
<input type="submit" name="logout" value="登出" id="logout">
<input type="hidden" name="token" value="',$He,'">
</p>
</form>
';}echo'<div id="menu">
';$b->navigation($Uc);echo'</div>
',script("setupSubmitHighlight(document);"),script("setupCopyToClipboard(document);"),"</body>\n</html>";}function
int32($D){while($D>=2147483648)$D-=4294967296;while($D<=-2147483649)$D+=4294967296;return(int)$D;}function
long2str($V,$df){$Td='';foreach($V
as$W)$Td.=pack('V',$W);if($df)return
substr($Td,0,end($V));return$Td;}function
str2long($Td,$df){$V=array_values(unpack('V*',str_pad($Td,4*ceil(strlen($Td)/4),"\0")));if($df)$V[]=strlen($Td);return$V;}function
xxtea_mx($if,$hf,$qe,$xc){return
int32((($if>>5&0x7FFFFFF)^$hf<<2)+(($hf>>3&0x1FFFFFFF)^$if<<4))^int32(($qe^$hf)+($xc^$if));}function
encrypt_string($le,$y){if($le=="")return"";$y=array_values(unpack("V*",pack("H*",md5($y))));$V=str2long($le,true);$D=count($V)-1;$if=$V[$D];$hf=$V[0];$Gd=floor(6+52/($D+1));$qe=0;while($Gd-->0){$qe=int32($qe+0x9E3779B9);$pb=$qe>>2&3;for($pd=0;$pd<$D;$pd++){$hf=$V[$pd+1];$Wc=xxtea_mx($if,$hf,$qe,$y[$pd&3^$pb]);$if=int32($V[$pd]+$Wc);$V[$pd]=$if;}$hf=$V[0];$Wc=xxtea_mx($if,$hf,$qe,$y[$pd&3^$pb]);$if=int32($V[$D]+$Wc);$V[$D]=$if;}return
long2str($V,false);}function
decrypt_string($le,$y){if($le=="")return"";if(!$y)return
false;$y=array_values(unpack("V*",pack("H*",md5($y))));$V=str2long($le,false);$D=count($V)-1;$if=$V[$D];$hf=$V[0];$Gd=floor(6+52/($D+1));$qe=int32($Gd*0x9E3779B9);while($qe){$pb=$qe>>2&3;for($pd=$D;$pd>0;$pd--){$if=$V[$pd-1];$Wc=xxtea_mx($if,$hf,$qe,$y[$pd&3^$pb]);$hf=int32($V[$pd]-$Wc);$V[$pd]=$hf;}$if=$V[$D];$Wc=xxtea_mx($if,$hf,$qe,$y[$pd&3^$pb]);$hf=int32($V[0]-$Wc);$V[0]=$hf;$qe=int32($qe-0x9E3779B9);}return
long2str($V,true);}$f='';$ec=$_SESSION["token"];if(!$ec)$_SESSION["token"]=rand(1,1e6);$He=get_token();$wd=array();if($_COOKIE["adminer_permanent"]){foreach(explode(" ",$_COOKIE["adminer_permanent"])as$W){list($y)=explode(":",$W);$wd[$y]=$W;}}function
add_invalid_login(){global$b;$o=file_open_lock(get_temp_dir()."/adminer.invalid");if(!$o)return;$uc=unserialize(stream_get_contents($o));$Ae=time();if($uc){foreach($uc
as$vc=>$W){if($W[0]<$Ae)unset($uc[$vc]);}}$tc=&$uc[$b->bruteForceKey()];if(!$tc)$tc=array($Ae+30*60,0);$tc[1]++;file_write_unlock($o,serialize($uc));}function
check_invalid_login(){global$b;$uc=unserialize(@file_get_contents(get_temp_dir()."/adminer.invalid"));$tc=($uc?$uc[$b->bruteForceKey()]:array());$Yc=($tc[1]>29?$tc[0]-time():0);if($Yc>0)auth_error(sprintf('登录失败次数过多，请 %d 分钟后重试。',ceil($Yc/60)));}$ra=$_POST["auth"];if($ra){session_regenerate_id();$Y=$ra["driver"];$P=$ra["server"];$U=$ra["username"];$I=(string)$ra["password"];$h=$ra["db"];set_password($Y,$P,$U,$I);$_SESSION["db"][$Y][$P][$U][$h]=true;if($ra["permanent"]){$y=base64_encode($Y)."-".base64_encode($P)."-".base64_encode($U)."-".base64_encode($h);$Dd=$b->permanentLogin(true);$wd[$y]="$y:".base64_encode($Dd?encrypt_string($I,$Dd):"");cookie("adminer_permanent",implode(" ",$wd));}if(count($_POST)==1||DRIVER!=$Y||SERVER!=$P||$_GET["username"]!==$U||DB!=$h)redirect(auth_url($Y,$P,$U,$h));}elseif($_POST["logout"]&&(!$ec||verify_token())){foreach(array("pwds","db","dbs","queries")as$y)set_session($y,null);unset_permanent();redirect(substr(preg_replace('~\b(username|db|ns)=[^&]*&~','',ME),0,-1),'成功登出。'.'.');}elseif($wd&&!$_SESSION["pwds"]){session_regenerate_id();$Dd=$b->permanentLogin();foreach($wd
as$y=>$W){list(,$Fa)=explode(":",$W);list($Y,$P,$U,$h)=array_map('base64_decode',explode("-",$y));set_password($Y,$P,$U,decrypt_string(base64_decode($Fa),$Dd));$_SESSION["db"][$Y][$P][$U][$h]=true;}}function
unset_permanent(){global$wd;foreach($wd
as$y=>$W){list($Y,$P,$U,$h)=array_map('base64_decode',explode("-",$y));if($Y==DRIVER&&$P==SERVER&&$U==$_GET["username"]&&$h==DB)unset($wd[$y]);}cookie("adminer_permanent",implode(" ",$wd));}function
auth_error($j){global$b,$ec;$ee=session_name();if(isset($_GET["username"])){header("HTTP/1.1 403 Forbidden");if(($_COOKIE[$ee]||$_GET[$ee])&&!$ec)$j='会话已过期，请重新登录。';else{restart_session();add_invalid_login();$I=get_password();if($I!==null){if($I===false)$j.=($j?'<br>':'').sprintf('主密码已过期。<a href="https://www.adminer.org/en/extension/"%s>请扩展</a> %s 方法让它永久化。',target_blank(),'<code>permanentLogin()</code>');set_password(DRIVER,SERVER,$_GET["username"],null);}unset_permanent();}}if(!$_COOKIE[$ee]&&$_GET[$ee]&&ini_bool("session.use_only_cookies"))$j='必须启用会话支持。';$sd=session_get_cookie_params();cookie("adminer_key",($_COOKIE["adminer_key"]?$_COOKIE["adminer_key"]:rand_string()),$sd["lifetime"]);page_header('登录',$j,null);echo"<form action='' method='post'>\n","<div>";if(hidden_fields($_POST,array("auth")))echo"<p class='message'>".'此操作将在成功使用相同的凭据登录后执行。'."\n";echo"</div>\n";$b->loginForm();echo"</form>\n";page_footer("auth");exit;}if(isset($_GET["username"])&&!class_exists("Min_DB")){unset($_SESSION["pwds"][DRIVER]);unset_permanent();page_header('没有扩展',sprintf('没有支持的 PHP 扩展可用（%s）。',implode(", ",$_d)),false);page_footer("auth");exit;}stop_session(true);if(isset($_GET["username"])&&is_string(get_password())){list($jc,$yd)=explode(":",SERVER,2);if(preg_match('~^\s*([-+]?\d+)~',$yd,$B)&&($B[1]<1024||$B[1]>65535))auth_error('不允许连接到特权端口。');check_invalid_login();$f=connect();$i=new
Min_Driver($f);}$Kc=null;if(!is_object($f)||($Kc=$b->login($_GET["username"],get_password()))!==true){$j=(is_string($f)?h($f):(is_string($Kc)?$Kc:'无效凭据。'));auth_error($j.(preg_match('~^ | $~',get_password())?'<br>'.'您输入的密码中有一个空格，这可能是导致问题的原因。':''));}if($_POST["logout"]&&$ec&&!verify_token()){page_header('登出','无效 CSRF 令牌。请重新发送表单。');page_footer("db");exit;}if($ra&&$_POST["token"])$_POST["token"]=$He;$j='';if($_POST){if(!verify_token()){$qc="max_input_vars";$Rc=ini_get($qc);if(extension_loaded("suhosin")){foreach(array("suhosin.request.max_vars","suhosin.post.max_vars")as$y){$W=ini_get($y);if($W&&(!$Rc||$W<$Rc)){$qc=$y;$Rc=$W;}}}$j=(!$_POST["token"]&&$Rc?sprintf('超过最多允许的字段数量。请增加 %s。',"'$qc'"):'无效 CSRF 令牌。请重新发送表单。'.' '.'如果您并没有从Adminer发送请求，请关闭此页面。');}}elseif($_SERVER["REQUEST_METHOD"]=="POST"){$j=sprintf('POST 数据太大。请减少数据或者增加 %s 配置命令。',"'post_max_size'");if(isset($_GET["sql"]))$j.=' '.'您可以通过FTP上传大型SQL文件并从服务器导入。';}function
email_header($fc){return"=?UTF-8?B?".base64_encode($fc)."?=";}function
send_mail($tb,$oe,$C,$Wb="",$Lb=array()){$zb=(DIRECTORY_SEPARATOR=="/"?"\n":"\r\n");$C=str_replace("\n",$zb,wordwrap(str_replace("\r","","$C\n")));$Aa=uniqid("boundary");$qa="";foreach((array)$Lb["error"]as$y=>$W){if(!$W)$qa.="--$Aa$zb"."Content-Type: ".str_replace("\n","",$Lb["type"][$y]).$zb."Content-Disposition: attachment; filename=\"".preg_replace('~["\n]~','',$Lb["name"][$y])."\"$zb"."Content-Transfer-Encoding: base64$zb$zb".chunk_split(base64_encode(file_get_contents($Lb["tmp_name"][$y])),76,$zb).$zb;}$xa="";$gc="Content-Type: text/plain; charset=utf-8$zb"."Content-Transfer-Encoding: 8bit";if($qa){$qa.="--$Aa--$zb";$xa="--$Aa$zb$gc$zb$zb";$gc="Content-Type: multipart/mixed; boundary=\"$Aa\"";}$gc.=$zb."MIME-Version: 1.0$zb"."X-Mailer: Adminer Editor".($Wb?$zb."From: ".str_replace("\n","",$Wb):"");return
mail($tb,email_header($oe),$xa.$C.$qa,$gc);}function
like_bool($k){return
preg_match("~bool|(tinyint|bit)\\(1\\)~",$k["full_type"]);}$f->select_db($b->database());$ed="RESTRICT|NO ACTION|CASCADE|SET NULL|SET DEFAULT";$mb[DRIVER]='登录';if(isset($_GET["select"])&&($_POST["edit"]||$_POST["clone"])&&!$_POST["save"])$_GET["edit"]=$_GET["select"];if(isset($_GET["download"])){$a=$_GET["download"];$l=fields($a);header("Content-Type: application/octet-stream");header("Content-Disposition: attachment; filename=".friendly_url("$a-".implode("_",$_GET["where"])).".".friendly_url($_GET["field"]));$O=array(idf_escape($_GET["field"]));$K=$i->select($a,$O,array(where($_GET,$l)),$O);$M=($K?$K->fetch_row():array());echo$i->value($M[0],$l[$_GET["field"]]);exit;}elseif(isset($_GET["edit"])){$a=$_GET["edit"];$l=fields($a);$Z=(isset($_GET["select"])?($_POST["check"]&&count($_POST["check"])==1?where_check($_POST["check"][0],$l):""):where($_GET,$l));$T=(isset($_GET["select"])?$_POST["edit"]:$Z);foreach($l
as$E=>$k){if(!isset($k["privileges"][$T?"update":"insert"])||$b->fieldName($k)==""||$k["generated"])unset($l[$E]);}if($_POST&&!$j&&!isset($_GET["select"])){$A=$_POST["referer"];if($_POST["insert"])$A=($T?null:$_SERVER["REQUEST_URI"]);elseif(!preg_match('~^.+&select=.+$~',$A))$A=ME."select=".urlencode($a);$v=indexes($a);$Qe=unique_array($_GET["where"],$v);$Jd="\nWHERE $Z";if(isset($_POST["delete"]))queries_redirect($A,'已删除项目。',$i->delete($a,$Jd,!$Qe));else{$Q=array();foreach($l
as$E=>$k){$W=process_input($k);if($W!==false&&$W!==null)$Q[idf_escape($E)]=$W;}if($T){if(!$Q)redirect($A);queries_redirect($A,'已更新项目。',$i->update($a,$Q,$Jd,!$Qe));if(is_ajax()){page_headers();page_messages($j);exit;}}else{$K=$i->insert($a,$Q);$Dc=($K?last_id():0);queries_redirect($A,sprintf('已插入项目%s。',($Dc?" $Dc":"")),$K);}}}$M=null;if($_POST["save"])$M=(array)$_POST["fields"];elseif($Z){$O=array();foreach($l
as$E=>$k){if(isset($k["privileges"]["select"])){$oa=convert_field($k);if($_POST["clone"]&&$k["auto_increment"])$oa="''";if($x=="sql"&&preg_match("~enum|set~",$k["type"]))$oa="1*".idf_escape($E);$O[]=($oa?"$oa AS ":"").idf_escape($E);}}$M=array();if(!support("table"))$O=array("*");if($O){$K=$i->select($a,$O,array($Z),$O,array(),(isset($_GET["select"])?2:1));if(!$K)$j=error();else{$M=$K->fetch_assoc();if(!$M)$M=false;}if(isset($_GET["select"])&&(!$M||$K->fetch_assoc()))$M=null;}}if(!support("table")&&!$l){if(!$Z){$K=$i->select($a,array("*"),$Z,array("*"));$M=($K?$K->fetch_assoc():false);if(!$M)$M=array($i->primary=>"");}if($M){foreach($M
as$y=>$W){if(!$Z)$M[$y]=null;$l[$y]=array("field"=>$y,"null"=>($y!=$i->primary),"auto_increment"=>($y==$i->primary));}}}edit_form($a,$l,$M,$T);}elseif(isset($_GET["select"])){$a=$_GET["select"];$ue=table_status1($a);$v=indexes($a);$l=fields($a);$Tb=column_foreign_keys($a);$dd=$ue["Oid"];parse_str($_COOKIE["adminer_import"],$ja);$Sd=array();$e=array();$ze=null;foreach($l
as$y=>$k){$E=$b->fieldName($k);if(isset($k["privileges"]["select"])&&$E!=""){$e[$y]=html_entity_decode(strip_tags($E),ENT_QUOTES);if(is_shortable($k))$ze=$b->selectLengthProcess();}$Sd+=$k["privileges"];}list($O,$q)=$b->selectColumnsProcess($e,$v);$w=count($q)<count($O)||strstr($O[0],"DISTINCT");$Z=$b->selectSearchProcess($l,$v);$G=$b->selectOrderProcess($l,$v);$z=$b->selectLimitProcess();if($_GET["val"]&&is_ajax()){header("Content-Type: text/plain; charset=utf-8");foreach($_GET["val"]as$Re=>$M){$oa=convert_field($l[key($M)]);$O=array($oa?$oa:idf_escape(key($M)));$Z[]=where_check($Re,$l);$L=$i->select($a,$O,$Z,$O);if($L)echo
reset($L->fetch_row());}exit;}$Bd=$Te=null;foreach($v
as$u){if($u["type"]=="PRIMARY"){$Bd=array_flip($u["columns"]);$Te=($O?$Bd:array());foreach($Te
as$y=>$W){if(in_array(idf_escape($y),$O))unset($Te[$y]);}break;}}if($dd&&!$Bd){$Bd=$Te=array($dd=>0);$v[]=array("type"=>"PRIMARY","columns"=>array($dd));}if($_POST&&!$j){$ff=$Z;if(!$_POST["all"]&&is_array($_POST["check"])){$Ea=array();foreach($_POST["check"]as$Ca)$Ea[]=where_check($Ca,$l);$ff[]="((".implode(") OR (",$Ea)."))";}$ff=($ff?"\nWHERE ".implode(" AND ",$ff):"");if($_POST["export"]){cookie("adminer_import","output=".urlencode($_POST["output"])."&format=".urlencode($_POST["format"]));dump_headers($a);$b->dumpTable($a,"");$Wb=($O?implode(", ",$O):"*").convert_fields($e,$l,$O)."\nFROM ".table($a);$Zb=($q&&$w?"\nGROUP BY ".implode(", ",$q):"").($G?"\nORDER BY ".implode(", ",$G):"");if(!is_array($_POST["check"])||$Bd)$J="SELECT $Wb$ff$Zb";else{$Pe=array();foreach($_POST["check"]as$W)$Pe[]="(SELECT".limit($Wb,"\nWHERE ".($Z?implode(" AND ",$Z)." AND ":"").where_check($W,$l).$Zb,1).")";$J=implode(" UNION ALL ",$Pe);}$b->dumpData($a,"table",$J);exit;}if(!$b->selectEmailProcess($Z,$Tb)){if($_POST["save"]||$_POST["delete"]){$K=true;$ka=0;$Q=array();if(!$_POST["delete"]){foreach($e
as$E=>$W){$W=process_input($l[$E]);if($W!==null&&($_POST["clone"]||$W!==false))$Q[idf_escape($E)]=($W!==false?$W:idf_escape($E));}}if($_POST["delete"]||$Q){if($_POST["clone"])$J="INTO ".table($a)." (".implode(", ",array_keys($Q)).")\nSELECT ".implode(", ",$Q)."\nFROM ".table($a);if($_POST["all"]||($Bd&&is_array($_POST["check"]))||$w){$K=($_POST["delete"]?$i->delete($a,$ff):($_POST["clone"]?queries("INSERT $J$ff"):$i->update($a,$Q,$ff)));$ka=$f->affected_rows;}else{foreach((array)$_POST["check"]as$W){$ef="\nWHERE ".($Z?implode(" AND ",$Z)." AND ":"").where_check($W,$l);$K=($_POST["delete"]?$i->delete($a,$ef,1):($_POST["clone"]?queries("INSERT".limit1($a,$J,$ef)):$i->update($a,$Q,$ef,1)));if(!$K)break;$ka+=$f->affected_rows;}}}$C=sprintf('%d 个项目受到影响。',$ka);if($_POST["clone"]&&$K&&$ka==1){$Dc=last_id();if($Dc)$C=sprintf('已插入项目%s。'," $Dc");}queries_redirect(remove_from_uri($_POST["all"]&&$_POST["delete"]?"page":""),$C,$K);if(!$_POST["delete"]){edit_form($a,$l,(array)$_POST["fields"],!$_POST["clone"]);page_footer();exit;}}elseif(!$_POST["import"]){if(!$_POST["val"])$j='按住Ctrl并单击某个值进行修改。';else{$K=true;$ka=0;foreach($_POST["val"]as$Re=>$M){$Q=array();foreach($M
as$y=>$W){$y=bracket_escape($y,1);$Q[idf_escape($y)]=(preg_match('~char|text~',$l[$y]["type"])||$W!=""?$b->processInput($l[$y],$W):"NULL");}$K=$i->update($a,$Q," WHERE ".($Z?implode(" AND ",$Z)." AND ":"").where_check($Re,$l),!$w&&!$Bd," ");if(!$K)break;$ka+=$f->affected_rows;}queries_redirect(remove_from_uri(),sprintf('%d 个项目受到影响。',$ka),$K);}}elseif(!is_string($Kb=get_file("csv_file",true)))$j=upload_error($Kb);elseif(!preg_match('~~u',$Kb))$j='文件必须使用UTF-8编码。';else{cookie("adminer_import","output=".urlencode($ja["output"])."&format=".urlencode($_POST["separator"]));$K=true;$Ma=array_keys($l);preg_match_all('~(?>"[^"]*"|[^"\r\n]+)+~',$Kb,$Nc);$ka=count($Nc[0]);$i->begin();$be=($_POST["separator"]=="csv"?",":($_POST["separator"]=="tsv"?"\t":";"));$N=array();foreach($Nc[0]as$y=>$W){preg_match_all("~((?>\"[^\"]*\")+|[^$be]*)$be~",$W.$be,$Oc);if(!$y&&!array_diff($Oc[1],$Ma)){$Ma=$Oc[1];$ka--;}else{$Q=array();foreach($Oc[1]as$r=>$Ja)$Q[idf_escape($Ma[$r])]=($Ja==""&&$l[$Ma[$r]]["null"]?"NULL":q(str_replace('""','"',preg_replace('~^"|"$~','',$Ja))));$N[]=$Q;}}$K=(!$N||$i->insertUpdate($a,$N,$Bd));if($K)$K=$i->commit();queries_redirect(remove_from_uri("page"),sprintf('%d 行已导入。',$ka),$K);$i->rollback();}}}$te=$b->tableName($ue);if(is_ajax()){page_headers();ob_start();}else
page_header('选择'.": $te",$j);$Q=null;if(isset($Sd["insert"])||!support("table")){$Q="";foreach((array)$_GET["where"]as$W){if($Tb[$W["col"]]&&count($Tb[$W["col"]])==1&&($W["op"]=="="||(!$W["op"]&&!preg_match('~[_%]~',$W["val"]))))$Q.="&set".urlencode("[".bracket_escape($W["col"])."]")."=".urlencode($W["val"]);}}$b->selectLinks($ue,$Q);if(!$e&&support("table"))echo"<p class='error'>".'不能选择该表'.($l?".":": ".error())."\n";else{echo"<form action='' id='form'>\n","<div style='display: none;'>";hidden_fields_get();echo(DB!=""?'<input type="hidden" name="db" value="'.h(DB).'">'.(isset($_GET["ns"])?'<input type="hidden" name="ns" value="'.h($_GET["ns"]).'">':""):"");echo'<input type="hidden" name="select" value="'.h($a).'">',"</div>\n";$b->selectColumnsPrint($O,$e);$b->selectSearchPrint($Z,$e,$v);$b->selectOrderPrint($G,$e,$v);$b->selectLimitPrint($z);$b->selectLengthPrint($ze);$b->selectActionPrint($v);echo"</form>\n";$H=$_GET["page"];if($H=="last"){$Vb=$f->result(count_rows($a,$Z,$w,$q));$H=floor(max(0,$Vb-1)/$z);}$Wd=$O;$Yb=$q;if(!$Wd){$Wd[]="*";$Va=convert_fields($e,$l,$O);if($Va)$Wd[]=substr($Va,2);}foreach($O
as$y=>$W){$k=$l[idf_unescape($W)];if($k&&($oa=convert_field($k)))$Wd[$y]="$oa AS $W";}if(!$w&&$Te){foreach($Te
as$y=>$W){$Wd[]=idf_escape($y);if($Yb)$Yb[]=idf_escape($y);}}$K=$i->select($a,$Wd,$Z,$Yb,$G,$z,$H,true);if(!$K)echo"<p class='error'>".error()."\n";else{if($x=="mssql"&&$H)$K->seek($z*$H);$vb=array();echo"<form action='' method='post' enctype='multipart/form-data'>\n";$N=array();while($M=$K->fetch_assoc()){if($H&&$x=="oracle")unset($M["RNUM"]);$N[]=$M;}if($_GET["page"]!="last"&&$z!=""&&$q&&$w&&$x=="sql")$Vb=$f->result(" SELECT FOUND_ROWS()");if(!$N)echo"<p class='message'>".'无数据。'."\n";else{$wa=$b->backwardKeys($a,$te);echo"<div class='scrollable'>","<table id='table' cellspacing='0' class='nowrap checkable'>",script("mixin(qs('#table'), {onclick: tableClick, ondblclick: partialArg(tableClick, true), onkeydown: editingKeydown});"),"<thead><tr>".(!$q&&$O?"":"<td><input type='checkbox' id='all-page' class='jsonly'>".script("qs('#all-page').onclick = partial(formCheck, /check/);","")." <a href='".h($_GET["modify"]?remove_from_uri("modify"):$_SERVER["REQUEST_URI"]."&modify=1")."' title='".'修改'."' class='edit-all'>".'修改'."</a>");$Xc=array();$Xb=array();reset($O);$Ld=1;foreach($N[0]as$y=>$W){if(!isset($Te[$y])){$W=$_GET["columns"][key($O)];$k=$l[$O?($W?$W["col"]:current($O)):$y];$E=($k?$b->fieldName($k,$Ld):($W["fun"]?"*":$y));if($E!=""){$Ld++;$Xc[$y]=$E;$d=idf_escape($y);$kc=remove_from_uri('(order|desc)[^=]*|page').'&order%5B0%5D='.urlencode($y);$gb="&desc%5B0%5D=1";echo"<th id='th[".h(bracket_escape($y))."]'>".script("mixin(qsl('th'), {onmouseover: partial(columnMouse), onmouseout: partial(columnMouse, ' hidden')});",""),'<a href="'.h($kc.($G[0]==$d||$G[0]==$y||(!$G&&$w&&$q[0]==$d)?$gb:'')).'">';echo
apply_sql_function($W["fun"],$E)."</a>";echo"<span class='column hidden'>","<a href='".h($kc.$gb)."' title='".'降序'."' class='text'> ↓</a>";if(!$W["fun"]){echo'<a href="#fieldset-search" title="'.'搜索'.'" class="text jsonly"> =</a>',script("qsl('a').onclick = partial(selectSearch, '".js_escape($y)."');");}echo"</span>";}$Xb[$y]=$W["fun"];next($O);}}$Gc=array();if($_GET["modify"]){foreach($N
as$M){foreach($M
as$y=>$W)$Gc[$y]=max($Gc[$y],min(40,strlen(utf8_decode($W))));}}echo($wa?"<th>".'关联信息':"")."</thead>\n";if(is_ajax()){if($z%2==1&&$H%2==1)odd();ob_end_clean();}foreach($b->rowDescriptions($N,$Tb)as$D=>$M){$Qe=unique_array($N[$D],$v);if(!$Qe){$Qe=array();foreach($N[$D]as$y=>$W){if(!preg_match('~^(COUNT\((\*|(DISTINCT )?`(?:[^`]|``)+`)\)|(AVG|GROUP_CONCAT|MAX|MIN|SUM)\(`(?:[^`]|``)+`\))$~',$y))$Qe[$y]=$W;}}$Re="";foreach($Qe
as$y=>$W){if(($x=="sql"||$x=="pgsql")&&preg_match('~char|text|enum|set~',$l[$y]["type"])&&strlen($W)>64){$y=(strpos($y,'(')?$y:idf_escape($y));$y="MD5(".($x!='sql'||preg_match("~^utf8~",$l[$y]["collation"])?$y:"CONVERT($y USING ".charset($f).")").")";$W=md5($W);}$Re.="&".($W!==null?urlencode("where[".bracket_escape($y)."]")."=".urlencode($W===false?"f":$W):"null%5B%5D=".urlencode($y));}echo"<tr".odd().">".(!$q&&$O?"":"<td>".checkbox("check[]",substr($Re,1),in_array(substr($Re,1),(array)$_POST["check"])).($w||information_schema(DB)?"":" <a href='".h(ME."edit=".urlencode($a).$Re)."' class='edit' title='".'编辑'."'>".'编辑'."</a>"));foreach($M
as$y=>$W){if(isset($Xc[$y])){$k=$l[$y];$W=$i->value($W,$k);if($W!=""&&(!isset($vb[$y])||$vb[$y]!=""))$vb[$y]=(is_mail($W)?$Xc[$y]:"");$_="";if(preg_match('~blob|bytea|raw|file~',$k["type"])&&$W!="")$_=ME.'download='.urlencode($a).'&field='.urlencode($y).$Re;if(!$_&&$W!==null){foreach((array)$Tb[$y]as$n){if(count($Tb[$y])==1||end($n["source"])==$y){$_="";foreach($n["source"]as$r=>$ie)$_.=where_link($r,$n["target"][$r],$N[$D][$ie]);$_=($n["db"]!=""?preg_replace('~([?&]db=)[^&]+~','\1'.urlencode($n["db"]),ME):ME).'select='.urlencode($n["table"]).$_;if($n["ns"])$_=preg_replace('~([?&]ns=)[^&]+~','\1'.urlencode($n["ns"]),$_);if(count($n["source"])==1)break;}}}if($y=="COUNT(*)"){$_=ME."select=".urlencode($a);$r=0;foreach((array)$_GET["where"]as$V){if(!array_key_exists($V["col"],$Qe))$_.=where_link($r++,$V["col"],$V["val"],$V["op"]);}foreach($Qe
as$xc=>$V)$_.=where_link($r++,$xc,$V);}$W=select_value($W,$_,$k,$ze);$s=h("val[$Re][".bracket_escape($y)."]");$X=$_POST["val"][$Re][bracket_escape($y)];$rb=!is_array($M[$y])&&is_utf8($W)&&$N[$D][$y]==$M[$y]&&!$Xb[$y];$ye=preg_match('~text|lob~',$k["type"]);echo"<td id='$s'";if(($_GET["modify"]&&$rb)||$X!==null){$bc=h($X!==null?$X:$M[$y]);echo">".($ye?"<textarea name='$s' cols='30' rows='".(substr_count($M[$y],"\n")+1)."'>$bc</textarea>":"<input name='$s' value='$bc' size='$Gc[$y]'>");}else{$Lc=strpos($W,"<i>…</i>");echo" data-text='".($Lc?2:($ye?1:0))."'".($rb?"":" data-warning='".h('使用编辑链接修改该值。')."'").">$W</td>";}}}if($wa)echo"<td>";$b->backwardKeysPrint($wa,$N[$D]);echo"</tr>\n";}if(is_ajax())exit;echo"</table>\n","</div>\n";}if(!is_ajax()){if($N||$H){$Db=true;if($_GET["page"]!="last"){if($z==""||(count($N)<$z&&($N||!$H)))$Vb=($H?$H*$z:0)+count($N);elseif($x!="sql"||!$w){$Vb=($w?false:found_rows($ue,$Z));if($Vb<max(1e4,2*($H+1)*$z))$Vb=reset(slow_query(count_rows($a,$Z,$w,$q)));else$Db=false;}}$qd=($z!=""&&($Vb===false||$Vb>$z||$H));if($qd){echo(($Vb===false?count($N)+1:$Vb-$H*$z)>$z?'<p><a href="'.h(remove_from_uri("page")."&page=".($H+1)).'" class="loadmore">'.'加载更多数据'.'</a>'.script("qsl('a').onclick = partial(selectLoadMore, ".(+$z).", '".'加载中'."…');",""):''),"\n";}}echo"<div class='footer'><div>\n";if($N||$H){if($qd){$Pc=($Vb===false?$H+(count($N)>=$z?2:1):floor(($Vb-1)/$z));echo"<fieldset>";if($x!="simpledb"){echo"<legend><a href='".h(remove_from_uri("page"))."'>".'页面'."</a></legend>",script("qsl('a').onclick = function () { pageClick(this.href, +prompt('".'页面'."', '".($H+1)."')); return false; };"),pagination(0,$H).($H>5?" …":"");for($r=max(1,$H-4);$r<min($Pc,$H+5);$r++)echo
pagination($r,$H);if($Pc>0){echo($H+5<$Pc?" …":""),($Db&&$Vb!==false?pagination($Pc,$H):" <a href='".h(remove_from_uri("page")."&page=last")."' title='~$Pc'>".'最后'."</a>");}}else{echo"<legend>".'页面'."</legend>",pagination(0,$H).($H>1?" …":""),($H?pagination($H,$H):""),($Pc>$H?pagination($H+1,$H).($Pc>$H+1?" …":""):"");}echo"</fieldset>\n";}echo"<fieldset>","<legend>".'所有结果'."</legend>";$kb=($Db?"":"~ ").$Vb;echo
checkbox("all",1,0,($Vb!==false?($Db?"":"~ ").sprintf('%d 行',$Vb):""),"var checked = formChecked(this, /check/); selectCount('selected', this.checked ? '$kb' : checked); selectCount('selected2', this.checked || !checked ? '$kb' : checked);")."\n","</fieldset>\n";if($b->selectCommandPrint()){echo'<fieldset',($_GET["modify"]?'':' class="jsonly"'),'><legend>修改</legend><div>
<input type="submit" value="保存"',($_GET["modify"]?'':' title="'.'按住Ctrl并单击某个值进行修改。'.'"'),'>
</div></fieldset>
<fieldset><legend>已选中 <span id="selected"></span></legend><div>
<input type="submit" name="edit" value="编辑">
<input type="submit" name="clone" value="复制">
<input type="submit" name="delete" value="删除">',confirm(),'</div></fieldset>
';}$Ub=$b->dumpFormat();foreach((array)$_GET["columns"]as$d){if($d["fun"]){unset($Ub['sql']);break;}}if($Ub){print_fieldset("export",'导出'." <span id='selected2'></span>");$od=$b->dumpOutput();echo($od?html_select("output",$od,$ja["output"])." ":""),html_select("format",$Ub,$ja["format"])," <input type='submit' name='export' value='".'导出'."'>\n","</div></fieldset>\n";}$b->selectEmailPrint(array_filter($vb,'strlen'),$e);}echo"</div></div>\n";if($b->selectImportPrint()){echo"<div>","<a href='#import'>".'导入'."</a>",script("qsl('a').onclick = partial(toggle, 'import');",""),"<span id='import' class='hidden'>: ","<input type='file' name='csv_file'> ",html_select("separator",array("csv"=>"CSV,","csv;"=>"CSV;","tsv"=>"TSV"),$ja["format"],1);echo" <input type='submit' name='import' value='".'导入'."'>","</span>","</div>";}echo"<input type='hidden' name='token' value='$He'>\n","</form>\n",(!$q&&$O?"":script("tableCheck();"));}}}if(is_ajax()){ob_end_clean();exit;}}elseif(isset($_GET["script"])){if($_GET["script"]=="kill")$f->query("KILL ".number($_POST["kill"]));elseif(list($S,$s,$E)=$b->_foreignColumn(column_foreign_keys($_GET["source"]),$_GET["field"])){$z=11;$K=$f->query("SELECT $s, $E FROM ".table($S)." WHERE ".(preg_match('~^[0-9]+$~',$_GET["value"])?"$s = $_GET[value] OR ":"")."$E LIKE ".q("$_GET[value]%")." ORDER BY 2 LIMIT $z");for($r=1;($M=$K->fetch_row())&&$r<$z;$r++)echo"<a href='".h(ME."edit=".urlencode($S)."&where".urlencode("[".bracket_escape(idf_unescape($s))."]")."=".urlencode($M[0]))."'>".h($M[1])."</a><br>\n";if($M)echo"...\n";}exit;}else{page_header('服务器',"",false);if($b->homepage()){echo"<form action='' method='post'>\n","<p>".'在表中搜索数据'.": <input type='search' name='query' value='".h($_POST["query"])."'> <input type='submit' value='".'搜索'."'>\n";if($_POST["query"]!="")search_tables();echo"<div class='scrollable'>\n","<table cellspacing='0' class='nowrap checkable'>\n",script("mixin(qsl('table'), {onclick: tableClick, ondblclick: partialArg(tableClick, true)});"),'<thead><tr class="wrap">','<td><input id="check-all" type="checkbox" class="jsonly">'.script("qs('#check-all').onclick = partial(formCheck, /^tables\[/);",""),'<th>'.'表','<td>'.'行数',"</thead>\n";foreach(table_status()as$S=>$M){$E=$b->tableName($M);if(isset($M["Engine"])&&$E!=""){echo'<tr'.odd().'><td>'.checkbox("tables[]",$S,in_array($S,(array)$_POST["tables"],true)),"<th><a href='".h(ME).'select='.urlencode($S)."'>$E</a>";$W=format_number($M["Rows"]);echo"<td align='right'><a href='".h(ME."edit=").urlencode($S)."'>".($M["Engine"]=="InnoDB"&&$W?"~ $W":$W)."</a>";}}echo"</table>\n","</div>\n","</form>\n",script("tableCheck();");}}page_footer();